/*******************************************************************************
 * Copyright (c) 2000, 2004 IBM Corporation and others. All rights reserved.
 * The contents of this file are made available under the terms
 * of the GNU Lesser General Public License (LGPL) Version 2.1 that
 * accompanies this distribution (lgpl-v21.txt).  The LGPL is also
 * available at http://www.gnu.org/licenses/lgpl.html.  If the version
 * of the LGPL at http://www.gnu.org is different to the version of
 * the LGPL accompanying this distribution and there is any conflict
 * between the two license versions, the terms of the LGPL accompanying
 * this distribution shall govern.
 *******************************************************************************/
package org.eclipse.swt.internal.gtk;

 
import org.eclipse.swt.internal.Library;

public class OS {
	static {
		Library.loadLibrary("swt-pi");
	}
	
	/** Constants */
	public static final int G_SIGNAL_MATCH_DATA = 1 << 4;
	public static final int G_SIGNAL_MATCH_ID = 1 << 0;
	public static final int GDK_2BUTTON_PRESS = 0x5;
	public static final int GDK_3BUTTON_PRESS = 0x6;
	public static final int GDK_ACTION_COPY = 1 << 1;
	public static final int GDK_ACTION_MOVE = 1 << 2;
	public static final int GDK_ACTION_LINK = 1 << 3;
	public static final int GDK_Alt_L = 0xffe9;
	public static final int GDK_Alt_R = 0xffea;
	public static final int GDK_AND = 4;
	public static final int GDK_BackSpace = 0xff08;
	public static final int GDK_BOTTOM_LEFT_CORNER = 0xc;
	public static final int GDK_BOTTOM_RIGHT_CORNER = 0xe;
	public static final int GDK_BOTTOM_SIDE = 0x10;
	public static final int GDK_BUTTON1_MASK = 0x100;
	public static final int GDK_BUTTON2_MASK = 0x200;
	public static final int GDK_BUTTON3_MASK = 0x400;
	public static final int GDK_BUTTON_MOTION_MASK	= 1 << 4;
	public static final int GDK_BUTTON1_MOTION_MASK	= 1 << 5;
	public static final int GDK_BUTTON2_MOTION_MASK	= 1 << 6;
	public static final int GDK_BUTTON3_MOTION_MASK	= 1 << 7;
	public static final int GDK_BUTTON_PRESS = 0x4;
	public static final int GDK_BUTTON_PRESS_MASK = 0x100;
	public static final int GDK_BUTTON_RELEASE = 0x7;
	public static final int GDK_BUTTON_RELEASE_MASK = 0x200;
	public static final int GDK_CAP_BUTT = 0x1;
	public static final int GDK_CAP_ROUND = 0x2;
	public static final int GDK_COLORSPACE_RGB = 0;
	public static final int GDK_CONFIGURE = 13;
	public static final int GDK_CONTROL_MASK = 0x4;
	public static final int GDK_COPY = 0x0;
	public static final int GDK_CROSS = 0x1e;
	public static final int GDK_CROSSING_NORMAL = 0;
	public static final int GDK_Break = 0xff6b;
	public static final int GDK_Cancel = 0xff69;
	public static final int GDK_Caps_Lock = 0xffE5;
	public static final int GDK_Clear = 0xff0B;
	public static final int GDK_Control_L = 0xffe3;
	public static final int GDK_Control_R = 0xffe4;
	public static final int GDK_CURRENT_TIME = 0x0;
	public static final int GDK_DECOR_BORDER = 0x2;
	public static final int GDK_DECOR_MAXIMIZE = 0x40;
	public static final int GDK_DECOR_MENU = 0x10;
	public static final int GDK_DECOR_MINIMIZE = 0x20;
	public static final int GDK_DECOR_RESIZEH = 0x4;
	public static final int GDK_DECOR_TITLE = 0x8;
	public static final int GDK_DOUBLE_ARROW = 0x2a;
	public static final int GDK_Delete = 0xffff;
	public static final int GDK_Down = 0xff54;
	public static final int GDK_ENTER_NOTIFY_MASK = 0x1000;
	public static final int GDK_ENTER_NOTIFY = 10;
	public static final int GDK_EVEN_ODD_RULE = 0;
	public static final int GDK_EXPOSE = 2;
	public static final int GDK_EXPOSURE_MASK = 0x2;
	public static final int GDK_End = 0xff57;
	public static final int GDK_Escape = 0xff1b;
	public static final int GDK_F1 = 0xffbe;
	public static final int GDK_F10 = 0xffc7;
	public static final int GDK_F11 = 0xffc8;
	public static final int GDK_F12 = 0xffc9;
	public static final int GDK_F13 = 0xffca;
	public static final int GDK_F14 = 0xffcb;
	public static final int GDK_F15 = 0xffcc;
	public static final int GDK_F2 = 0xffbf;
	public static final int GDK_F3 = 0xffc0;
	public static final int GDK_F4 = 0xffc1;
	public static final int GDK_F5 = 0xffc2;
	public static final int GDK_F6 = 0xffc3;
	public static final int GDK_F7 = 0xffc4;
	public static final int GDK_F8 = 0xffc5;
	public static final int GDK_F9 = 0xffc6;
	public static final int GDK_FLEUR = 0x34;
	public static final int GDK_FOCUS_CHANGE = 0xc;
	public static final int GDK_FOCUS_CHANGE_MASK = 0x4000;
	public static final int GDK_GC_CLIP_MASK = 0x80;
	public static final int GDK_GC_CLIP_X_ORIGIN = 0x800;
	public static final int GDK_GC_CLIP_Y_ORIGIN = 0x1000;
	public static final int GDK_GRAB_SUCCESS = 0x0;
	public static final int GDK_HAND1 = 0x3a;
	public static final int GDK_Help = 0xFF6A;
	public static final int GDK_Home = 0xff50;
	public static final int GDK_INCLUDE_INFERIORS = 0x1;
	public static final int GDK_INPUT_ONLY = 1;
	public static final int GDK_INTERP_BILINEAR = 0x2;
	public static final int GDK_Insert = 0xff63;
	public static final int GDK_ISO_Left_Tab = 0xfe20;
	public static final int GDK_JOIN_MITER = 0x0;
	public static final int GDK_KEY_PRESS = 0x8;
	public static final int GDK_KEY_PRESS_MASK = 0x400;
	public static final int GDK_KEY_RELEASE = 0x9;
	public static final int GDK_KEY_RELEASE_MASK = 0x800;
	public static final int GDK_KP_0 = 0xffb0;
	public static final int GDK_KP_1 = 0xffb1;
	public static final int GDK_KP_2 = 0xffb2;
	public static final int GDK_KP_3 = 0xffb3;
	public static final int GDK_KP_4 = 0xffb4;
	public static final int GDK_KP_5 = 0xffb5;
	public static final int GDK_KP_6 = 0xffb6;
	public static final int GDK_KP_7 = 0xffb7;
	public static final int GDK_KP_8 = 0xffb8;
	public static final int GDK_KP_9 = 0xffb9;
	public static final int GDK_KP_Add = 0xffab;
	public static final int GDK_KP_Decimal = 0xffae;
	public static final int GDK_KP_Delete = 0xFF9F;
	public static final int GDK_KP_Divide = 0xffaf;
	public static final int GDK_KP_Down = 0xFF99;
	public static final int GDK_KP_End = 0xFF9C;
	public static final int GDK_KP_Enter = 0xff8d;
	public static final int GDK_KP_Equal = 0xffbd;
	public static final int GDK_KP_Home = 0xFF95;
	public static final int GDK_KP_Insert = 0xFF9E;
	public static final int GDK_KP_Left = 0xFF96;
	public static final int GDK_KP_Multiply = 0xffaa;
	public static final int GDK_KP_Page_Down = 0xFF9B;
	public static final int GDK_KP_Page_Up = 0xFF9A;
	public static final int GDK_KP_Right = 0xFF98;
	public static final int GDK_KP_Subtract = 0xffad;
	public static final int GDK_KP_Up = 0xFF97;
	public static final int GDK_LEAVE_NOTIFY = 11;
	public static final int GDK_LEAVE_NOTIFY_MASK = 0x2000;
	public static final int GDK_LEFT_PTR = 0x44;
	public static final int GDK_LEFT_SIDE = 0x46;
	public static final int GDK_LINE_ON_OFF_DASH = 0x1;
	public static final int GDK_LINE_SOLID = 0x0;
	public static final int GDK_Linefeed = 0xff0A;
	public static final int GDK_LSB_FIRST = 0x0;
	public static final int GDK_Left = 0xff51;
	public static final int GDK_Meta_L = 0xFFE7;
	public static final int GDK_Meta_R = 0xFFE8;
	public static final int GDK_MAP = 14;
	public static final int GDK_MOD1_MASK = 0x8;
	public static final int GDK_MOTION_NOTIFY = 0x3;
	public static final int GDK_NO_EXPOSE = 30;
	public static final int GDK_NONE = 0;
	public static final int GDK_NOTIFY_INFERIOR = 2;
	public static final int PANGO_ALIGN_LEFT = 0;
	public static final int PANGO_ALIGN_CENTER = 1;
	public static final int PANGO_ALIGN_RIGHT = 2;
	public static final int PANGO_DIRECTION_LTR = 0;
	public static final int PANGO_DIRECTION_RTL = 1;	
	public static final int GDK_Num_Lock = 0xFF7F;
	public static final int GDK_OVERLAP_RECTANGLE_OUT = 0x1;
	public static final int GDK_PIXBUF_ALPHA_BILEVEL = 0x0;
	public static final int GDK_POINTER_MOTION_HINT_MASK = 0x8;
	public static final int GDK_POINTER_MOTION_MASK = 0x4;
	public static final int GDK_PROPERTY_NOTIFY = 16;
	public static final int GDK_Page_Down = 0xff56;
	public static final int GDK_Page_Up = 0xff55;
	public static final int GDK_Pause = 0xff13;
	public static final int GDK_Print = 0xff61;
	public static final int GDK_QUESTION_ARROW = 0x5c;
	public static final int GDK_RGB_DITHER_NORMAL = 0x1;
	public static final int GDK_RIGHT_SIDE = 0x60;
	public static final int GDK_Return = 0xff0d;
	public static final int GDK_Right = 0xff53;
	public static final int GDK_space = 0x20;
	public static final int GDK_SB_H_DOUBLE_ARROW = 0x6c;
	public static final int GDK_SB_UP_ARROW = 0x72;
	public static final int GDK_SB_V_DOUBLE_ARROW = 0x74;
	public static final int GDK_SELECTION_CLEAR = 17;
	public static final int GDK_SELECTION_NOTIFY = 19;
	public static final int GDK_SELECTION_REQUEST = 18;
	public static final int GDK_SHIFT_MASK = 0x1;
	public static final int GDK_SIZING = 0x78;
	public static final int GDK_STIPPLED = 0x2;
	public static final int GDK_Shift_L = 0xffe1;
	public static final int GDK_Shift_R = 0xffe2;
	public static final int GDK_Scroll_Lock = 0xff14;
	public static final int GDK_TOP_LEFT_CORNER = 0x86;
	public static final int GDK_TOP_RIGHT_CORNER = 0x88;
	public static final int GDK_TOP_SIDE = 0x8a;
	public static final int GDK_Tab = 0xff09;
	public static final int GDK_Up = 0xff52;
	public static final int GDK_WATCH = 0x96;
	public static final int GDK_XOR = 0x2;
	public static final int GDK_XTERM = 0x98;
	public static final int GDK_X_CURSOR = 0x0;
	public static final int GDK_VISIBILITY_FULLY_OBSCURED = 2;
	public static final int GDK_VISIBILITY_NOTIFY_MASK = 1 << 17;
	public static final int GDK_WINDOW_CHILD = 2;
	public static final int GDK_WINDOW_STATE_ICONIFIED  = 1 << 1;
	public static final int GDK_WINDOW_STATE_MAXIMIZED  = 1 << 2;
	public static final int GTK_ACCEL_VISIBLE = 0x1;
	public static final int GTK_ARROW_DOWN = 0x1;
	public static final int GTK_ARROW_LEFT = 0x2;
	public static final int GTK_ARROW_RIGHT = 0x3;
	public static final int GTK_ARROW_UP = 0x0;
	public static final int GTK_CAN_DEFAULT = 0x2000;
	public static final int GTK_CAN_FOCUS = 0x800;
	public static final int GTK_CELL_RENDERER_MODE_ACTIVATABLE = 1;
	public static final int GTK_CLIST_SHOW_TITLES = 0x4;
	public static final int GTK_CORNER_TOP_LEFT = 0x0;
	public static final int GTK_CORNER_TOP_RIGHT = 0x2;
	public static final int GTK_DIALOG_DESTROY_WITH_PARENT = 1 << 1;
	public static final int GTK_DIALOG_MODAL = 1 << 0;
	public static final int GTK_DIR_TAB_FORWARD = 0;
	public static final int GTK_DIR_TAB_BACKWARD = 1;
	public static final int GTK_HAS_FOCUS = 1 << 12;
	public static final int GTK_JUSTIFY_CENTER = 0x2;
	public static final int GTK_JUSTIFY_LEFT = 0x0;
	public static final int GTK_JUSTIFY_RIGHT = 0x1;
	public static final int GTK_MESSAGE_INFO = 0;
	public static final int GTK_MESSAGE_WARNING = 1;
	public static final int GTK_MESSAGE_QUESTION = 2;
	public static final int GTK_MESSAGE_ERROR = 3;
	public static final int GTK_NO_WINDOW = 1 << 5;
	public static final int GTK_ORIENTATION_HORIZONTAL = 0x0;
	public static final int GTK_ORIENTATION_VERTICAL = 0x1;
	public static final int GTK_POLICY_ALWAYS = 0x0;
	public static final int GTK_POLICY_AUTOMATIC = 0x1;
	public static final int GTK_POLICY_NEVER = 0x2;
	public static final int GTK_POS_BOTTOM = 0x3;
	public static final int GTK_PROGRESS_CONTINUOUS = 0x0;
	public static final int GTK_PROGRESS_DISCRETE = 0x1;
	public static final int GTK_PROGRESS_LEFT_TO_RIGHT = 0x0;
	public static final int GTK_PROGRESS_BOTTOM_TO_TOP = 0x2;
	public static final int GTK_REALIZED  = 1 << 6;
	public static final int GTK_RELIEF_NONE = 0x2;
	public static final int GTK_RC_BG = 1 << 1;
	public static final int GTK_RC_FG = 1 << 0;
	public static final int GTK_RESPONSE_OK = 0xfffffffb;
	public static final int GTK_SELECTION_BROWSE = 0x2;
	public static final int GTK_SELECTION_MULTIPLE = 0x3;
	public static final int GTK_SENSITIVE = 0x200;
	public static final int GTK_SHADOW_ETCHED_IN = 0x3;
	public static final int GTK_SHADOW_ETCHED_OUT = 0x4;
	public static final int GTK_SHADOW_IN = 0x1;
	public static final int GTK_SHADOW_NONE = 0x0;
	public static final int GTK_SHADOW_OUT = 0x2;
	public static final int GTK_STATE_ACTIVE = 0x1;
	public static final int GTK_STATE_INSENSITIVE = 0x4;
	public static final int GTK_STATE_NORMAL = 0x0;
	public static final int GTK_STATE_PRELIGHT = 0x2;
	public static final int GTK_STATE_SELECTED = 0x3;
	public static final int GTK_TEXT_DIR_LTR = 1;
	public static final int GTK_TEXT_DIR_NONE = 0 ;
	public static final int GTK_TEXT_DIR_RTL = 2;
	public static final int GTK_TEXT_WINDOW_TEXT = 2;
	public static final int GTK_TOOLBAR_CHILD_BUTTON = 0x1;
	public static final int GTK_TOOLBAR_CHILD_RADIOBUTTON = 0x3;
	public static final int GTK_TOOLBAR_CHILD_TOGGLEBUTTON = 0x2;
	public static final int GTK_TREE_VIEW_COLUMN_GROW_ONLY = 0;
	public static final int GTK_TREE_VIEW_COLUMN_AUTOSIZE = 1;
	public static final int GTK_TREE_VIEW_COLUMN_FIXED = 2;
	public static final int GTK_TREE_VIEW_DROP_BEFORE = 0;
	public static final int GTK_TREE_VIEW_DROP_AFTER = 1;
	public static final int GTK_TREE_VIEW_DROP_INTO_OR_BEFORE = 2;
	public static final int GTK_TREE_VIEW_DROP_INTO_OR_AFTER = 3;
	public static final int GDK_UNMAP = 15;
	public static final int GTK_VISIBILITY_FULL = 0x2;
	public static final int GTK_VISIBILITY_NONE = 0x0;
	public static final int GTK_VISIBLE = 0x100;
	public static final int GDK_WA_X = 1 << 2;
	public static final int GDK_WA_Y = 1 << 3;
	public static final int GTK_WINDOW_POPUP = 0x1;
	public static final int GTK_WINDOW_TOPLEVEL = 0x0;
	public static final int GDK_WINDOW_TYPE_HINT_DIALOG = 1;
	public static final int GTK_WRAP_NONE = 0;
	public static final int GTK_WRAP_WORD = 2;
	public static final int G_LOG_FLAG_FATAL = 0x2;
	public static final int G_LOG_FLAG_RECURSION = 0x1;
	public static final int G_LOG_LEVEL_MASK = 0xfffffffc;
	public static final int None = 0;
	public static final int PANGO_SCALE = 1024;
	public static final int PANGO_STRETCH_NORMAL = 0x4;
	public static final int PANGO_STYLE_ITALIC = 0x2;
	public static final int PANGO_STYLE_NORMAL = 0x0;
	public static final int PANGO_STYLE_OBLIQUE = 0x1;
	public static final int PANGO_TAB_LEFT = 0;
	public static final int PANGO_UNDERLINE_LOW = 3;
	public static final int PANGO_UNDERLINE_SINGLE = 1;
	public static final int PANGO_WEIGHT_BOLD = 0x2bc;
	public static final int PANGO_WEIGHT_NORMAL = 0x190;
	public static final int PANGO_WRAP_WORD = 0;
	public static final int PANGO_WRAP_WORD_CHAR = 2;
	public static final int XA_CARDINAL = 0x6;
	
	/** Signals */
	public static final byte[] activate = signal("activate");
	public static final byte[] button_press_event = signal("button_press_event");
	public static final byte[] button_release_event = signal("button_release_event");
	public static final byte[] changed = signal("changed");
	public static final byte[] change_current_page = signal("change_current_page");
	public static final byte[] clicked = signal("clicked");
	public static final byte[] commit = signal("commit");
	public static final byte[] configure_event = signal("configure_event");
	public static final byte[] delete_event = signal("delete_event");
	public static final byte[] delete_range = signal("delete_range");
	public static final byte[] delete_text = signal("delete_text");
	public static final byte[] enter_notify_event = signal("enter_notify_event");
	public static final byte[] event = signal("event");
	public static final byte[] event_after = signal("event_after");
	public static final byte[] expose_event = signal("expose_event");
	public static final byte[] focus = signal("focus");
	public static final byte[] focus_in_event = signal("focus_in_event");
	public static final byte[] focus_out_event = signal("focus_out_event");
	public static final byte[] hide = signal("hide");
	public static final byte[] insert_text = signal("insert_text");
	public static final byte[] key_press_event = signal("key_press_event");
	public static final byte[] key_release_event = signal("key_release_event");
	public static final byte[] leave_notify_event = signal("leave_notify_event");
	public static final byte[] map_event = signal("map_event");
	public static final byte[] mnemonic_activate = signal("mnemonic_activate");
	public static final byte[] motion_notify_event = signal("motion_notify_event");
	public static final byte[] popup_menu = signal("popup_menu");
	public static final byte[] preedit_changed = signal("preedit_changed");
	public static final byte[] realize = signal("realize");
	public static final byte[] row_activated = signal("row_activated");
	public static final byte[] row_changed = signal("row_changed");
	public static final byte[] scroll_child = signal("scroll_child");
	public static final byte[] select = signal("select");
	public static final byte[] show = signal("show");
	public static final byte[] show_help = signal("show_help");
	public static final byte[] size_allocate = signal("size_allocate");
	public static final byte[] style_set = signal("style_set");
	public static final byte[] switch_page = signal("switch_page");
	public static final byte[] test_collapse_row = signal("test_collapse_row");
	public static final byte[] test_expand_row = signal("test_expand_row");
	public static final byte[] toggled = signal("toggled");
	public static final byte[] unmap_event = signal("unmap_event");
	public static final byte[] unrealize = signal("unrealize");
	public static final byte[] value_changed = signal("value_changed");
	public static final byte[] visibility_notify_event = signal("visibility_notify_event");
	public static final byte[] window_state_event = signal("window_state_event");
	
	/** Properties */
	public static final byte[] background_gdk = signal("background-gdk");
	public static final byte[] button_relief = signal("button_relief");
	public static final byte[] cell_background_gdk = signal("cell-background-gdk");
	public static final byte[] expander_size = signal("expander-size");
	public static final byte[] fixed_height_mode = signal("fixed-height-mode");
	public static final byte[] focus_line_width = signal("focus_line_width");
	public static final byte[] font_desc = signal("font-desc");
	public static final byte[] foreground_gdk = signal("foreground-gdk");
	public static final byte[] horizontal_separator = signal("horizontal_separator");
	public static final byte[] interior_focus = signal("interior_focus");
	public static final byte[] mode = signal("mode");
	public static final byte[] pixbuf = signal("pixbuf");
	public static final byte[] text = signal("text");
	public static final byte[] xalign = signal("xalign");
	
protected static byte [] signal (String name) {
	int length = name.length ();
	char [] chars = new char [length];
	name.getChars (0, length, chars, 0);
	byte [] buffer = new byte [length + 1];
	for (int i=0; i<length; i++) {
		buffer [i] = (byte) chars [i];
	}
	return buffer;
}

/** 64 bit */
public static final int PTR_SIZEOF = PTR_sizeof();
public static final synchronized native int PTR_sizeof();
public static final synchronized native int GdkColor_sizeof();
public static final synchronized native int GdkDragContext_sizeof();
public static final synchronized native int GdkEvent_sizeof();
public static final synchronized native int GdkEventButton_sizeof();
public static final synchronized native int GdkEventCrossing_sizeof();
public static final synchronized native int GdkEventExpose_sizeof();
public static final synchronized native int GdkEventFocus_sizeof();
public static final synchronized native int GdkEventKey_sizeof();
public static final synchronized native int GdkEventMotion_sizeof();
public static final synchronized native int GdkEventVisibility_sizeof();
public static final synchronized native int GdkEventWindowState_sizeof();
public static final synchronized native int GdkGCValues_sizeof();
public static final synchronized native int GdkImage_sizeof();
public static final synchronized native int GdkRectangle_sizeof();
public static final synchronized native int GdkVisual_sizeof();
public static final synchronized native int GdkWindowAttr_sizeof();
public static final synchronized native int GtkAdjustment_sizeof();
public static final synchronized native int GtkAllocation_sizeof();
public static final synchronized native int GtkColorSelectionDialog_sizeof();
public static final synchronized native int GtkCombo_sizeof();
public static final synchronized native int GtkFileSelection_sizeof();
public static final synchronized native int GtkFixed_sizeof();
public static final synchronized native int GtkRequisition_sizeof();
public static final synchronized native int GtkSelectionData_sizeof();
public static final synchronized native int GtkTargetEntry_sizeof();
public static final synchronized native int GtkTargetPair_sizeof();
public static final synchronized native int GtkTextIter_sizeof();
public static final synchronized native int GtkTreeIter_sizeof();
public static final synchronized native int PangoAttribute_sizeof();
public static final synchronized native int PangoItem_sizeof();
public static final synchronized native int PangoLayoutLine_sizeof();
public static final synchronized native int PangoLayoutRun_sizeof();
public static final synchronized native int PangoLogAttr_sizeof();
public static final synchronized native int PangoRectangle_sizeof();
public static final synchronized native int XAnyEvent_sizeof();
public static final synchronized native int XClientMessageEvent_sizeof();
public static final synchronized native int XEvent_sizeof();
public static final synchronized native int XCrossingEvent_sizeof();
public static final synchronized native int XExposeEvent_sizeof();
public static final synchronized native int XFocusChangeEvent_sizeof();
public static final synchronized native int XVisibilityEvent_sizeof();
public static final synchronized native int XWindowChanges_sizeof();
public static final native int strlen(long /*int*/ str);

/** Object private fields accessors */
public static final synchronized native int GTK_WIDGET_HEIGHT(long /*int*/ widget);
public static final synchronized native int GTK_WIDGET_WIDTH(long /*int*/ widget);
public static final synchronized native long /*int*/ GTK_WIDGET_WINDOW(long /*int*/ widget);
public static final synchronized native int GTK_WIDGET_X(long /*int*/ widget);
public static final synchronized native int GTK_WIDGET_Y(long /*int*/ widget);
public static final synchronized native long /*int*/ GTK_SCROLLED_WINDOW_HSCROLLBAR(long /*int*/ widget);
public static final synchronized native long /*int*/ GTK_SCROLLED_WINDOW_VSCROLLBAR(long /*int*/ widget);
public static final synchronized native int GTK_SCROLLED_WINDOW_SCROLLBAR_SPACING(long /*int*/ widget);
public static final synchronized native void GTK_ACCEL_LABEL_SET_ACCEL_STRING(long /*int*/ acce_label, long /*int*/ string);
public static final synchronized native long /*int*/ GTK_ACCEL_LABEL_GET_ACCEL_STRING(long /*int*/ acce_label);
public static final synchronized native long /*int*/ GTK_ENTRY_IM_CONTEXT(long /*int*/ widget);
public static final synchronized native long /*int*/ GTK_TEXTVIEW_IM_CONTEXT(long /*int*/ widget);

/** X11 Native methods and constants */
public static final int Above = 0;
public static final int Below = 1;
public static final int ClientMessage = 33;
public static final int CWSibling = 0x20;
public static final int CWStackMode = 0x40;
public static final int EnterNotify = 7;
public static final int Expose = 12;
public static final int FocusChangeMask = 1 << 21;
public static final int FocusIn = 9;
public static final int FocusOut = 10;
public static final int GraphicsExpose = 13;
public static final int NoExpose = 14;
public static final int ExposureMask = 1 << 15;
public static final int NotifyNonlinear = 3;
public static final int NotifyPointer = 5;
public static final int VisibilityChangeMask = 1 << 16;
public static final int VisibilityFullyObscured = 2;
public static final int VisibilityNotify = 15;
public static final native boolean GDK_WINDOWING_X11();
public static final long /*int*/ NoEventMask = 0;
public static final int RevertToParent = 2;
public static final int SYSTEM_TRAY_REQUEST_DOCK = 0;
public static final synchronized native boolean XCheckMaskEvent(long /*int*/ display, long /*int*/ event_mask, long /*int*/ event_return);
public static final synchronized native boolean XCheckWindowEvent(long /*int*/ display, long /*int*/ window, long /*int*/ event_mask, long /*int*/ event_return);
public static final synchronized native boolean XCheckIfEvent(long /*int*/ display, long /*int*/ event_return, long /*int*/ predicate, long /*int*/ arg);
public static final synchronized native int XDefaultScreen(long /*int*/ display);
public static final synchronized native long /*int*/ XGetSelectionOwner(long /*int*/ display, long /*int*/ selection);
public static final synchronized native int XQueryTree(long /*int*/ display, long /*int*/ w, long /*int*/[] root_return, long /*int*/[] parent_return, long /*int*/[] children_return, int[] nchildren_return);
public static final synchronized native int XKeysymToKeycode(long /*int*/ display, long /*int*/ keysym);
public static final synchronized native int XReconfigureWMWindow(long /*int*/ display, long /*int*/ window, int screen, int valueMask, XWindowChanges values);
public static final synchronized native int XSendEvent(long /*int*/ display, long /*int*/ w, boolean propogate, long /*int*/ event_mask, long /*int*/ event_send);
public static final synchronized native int XSetInputFocus(long /*int*/ display, long /*int*/ window, int revert, int time);
public static final synchronized native long /*int*/ XSynchronize(long /*int*/ display, boolean onoff);
public static final synchronized native void XTestFakeButtonEvent(long /*int*/ display, int button, boolean is_press, long /*int*/ delay);
public static final synchronized native void XTestFakeKeyEvent(long /*int*/ display, int keycode, boolean is_press, long /*int*/ delay);
public static final synchronized native void XTestFakeMotionEvent(long /*int*/ display, int screen_number, int x, int y, long /*int*/ delay);
public static final synchronized native long /*int*/gdk_x11_atom_to_xatom(long /*int*/ atom);
public static final synchronized native long /*int*/ gdk_x11_drawable_get_xdisplay(long /*int*/ drawable);
public static final synchronized native long /*int*/ gdk_x11_drawable_get_xid(long /*int*/ drawable);
public static final synchronized native long /*int*/ gdk_window_lookup(long /*int*/ xid);
public static final synchronized native void gdk_window_add_filter(long /*int*/ window, long /*int*/ function, long /*int*/ data);
public static final native void memmove(long /*int*/ dest, XClientMessageEvent src, long /*int*/ size);
public static final native void memmove(long /*int*/ dest, XCrossingEvent src, long /*int*/ size);
public static final native void memmove(long /*int*/ dest, XExposeEvent src, long /*int*/ size);
public static final native void memmove(long /*int*/ dest, XFocusChangeEvent src, long /*int*/ size);
public static final native void memmove(XCrossingEvent dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(XExposeEvent dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(XFocusChangeEvent dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(XVisibilityEvent dest, long /*int*/ src, long /*int*/ size);

/** Native methods */
public static final synchronized native long /*int*/ GDK_DISPLAY();
public static final synchronized native long /*int*/ GDK_ROOT_PARENT();
public static final synchronized native long /*int*/ GDK_TYPE_COLOR();
public static final synchronized native long /*int*/ GDK_TYPE_PIXBUF();
public static final synchronized native boolean GTK_IS_BUTTON(long /*int*/ obj);
public static final synchronized native boolean GTK_IS_CELL_RENDERER_PIXBUF(long /*int*/ obj);
public static final synchronized native boolean GTK_IS_IMAGE_MENU_ITEM(long /*int*/ obj);
public static final synchronized native int GTK_WIDGET_FLAGS(long /*int*/ wid);
public static final synchronized native boolean GTK_WIDGET_HAS_DEFAULT(long /*int*/ wid);
public static final synchronized native boolean GTK_WIDGET_HAS_FOCUS(long /*int*/ wid);
public static final synchronized native boolean GTK_WIDGET_IS_SENSITIVE(long /*int*/ wid);
public static final synchronized native boolean GTK_WIDGET_MAPPED(long /*int*/ wid);
public static final synchronized native boolean GTK_WIDGET_SENSITIVE(long /*int*/ wid);
public static final synchronized native void GTK_WIDGET_SET_FLAGS(long /*int*/ wid, int flag);
public static final synchronized native void GTK_WIDGET_UNSET_FLAGS(long /*int*/ wid, int flag);
public static final synchronized native boolean GTK_WIDGET_VISIBLE(long /*int*/ wid);
public static final synchronized native long /*int*/ G_TYPE_BOOLEAN();
public static final synchronized native long /*int*/ G_TYPE_INT();
public static final synchronized native long /*int*/ G_TYPE_STRING();
public static final synchronized native int PANGO_PIXELS(int dimension);
public static final synchronized native long /*int*/ PANGO_TYPE_FONT_DESCRIPTION();
public static final synchronized native long /*int*/ g_filename_to_utf8(long /*int*/ opsysstring, long /*int*/ len, long /*int*/[] bytes_read, long /*int*/[] bytes_written, long /*int*/[] error);
public static final synchronized native long /*int*/ g_filename_to_uri(long /*int*/ filename, long /*int*/ hostname, long /*int*/[] error);
public static final synchronized native long /*int*/ g_filename_from_utf8(long /*int*/ opsysstring, long /*int*/ len,  long /*int*/[] bytes_read, long /*int*/[] bytes_written, long /*int*/[] error);
public static final synchronized native long /*int*/ g_filename_from_uri(long /*int*/ uri, long /*int*/[] hostname, long /*int*/[] error);
public static final synchronized native void g_free(long /*int*/ mem);
public static final synchronized native long /*int*/ g_list_append(long /*int*/ list, long /*int*/ data);
public static final synchronized native long /*int*/ g_list_data(long /*int*/ list);
public static final synchronized native void g_list_free(long /*int*/ list);
public static final synchronized native void g_list_free_1(long /*int*/ list);
public static final synchronized native int g_list_length(long /*int*/ list);
public static final synchronized native void g_list_set_next(long /*int*/ list, long /*int*/ llist);
public static final synchronized native long /*int*/ g_list_next(long /*int*/ list);
public static final synchronized native long /*int*/ g_list_nth(long /*int*/ list, int n);
public static final synchronized native long /*int*/ g_list_nth_data(long /*int*/ list, int n);
public static final synchronized native long /*int*/ g_list_prepend(long /*int*/ list, long /*int*/ data);
public static final synchronized native void g_list_set_previous(long /*int*/ list, long /*int*/ llist);
public static final synchronized native long /*int*/ g_list_previous(long /*int*/ list);
public static final synchronized native long /*int*/ g_list_remove_link(long /*int*/ list, long /*int*/ link);
public static final synchronized native long /*int*/ g_list_reverse(long /*int*/ list);
public static final synchronized native long /*int*/ g_locale_from_utf8(long /*int*/ utf8string, long /*int*/ len, long /*int*/[] bytes_read, long /*int*/[] bytes_written, long /*int*/[] error);
public static final synchronized native long /*int*/ g_locale_to_utf8(long /*int*/ opsysstring, long /*int*/ len, long /*int*/[] bytes_read, long /*int*/[] bytes_written, long /*int*/[] error);
public static final synchronized native void g_log_default_handler(long /*int*/ log_domain, int log_levels, long /*int*/ message, long /*int*/ unused_data);
public static final synchronized native void g_log_remove_handler(byte[] log_domain, int handler_id);
public static final synchronized native int g_log_set_handler(byte[] log_domain, int log_levels, long /*int*/ log_func, long /*int*/ user_data);
public static final synchronized native long /*int*/ g_malloc(long /*int*/ size);
public static final synchronized native long /*int*/ g_object_get_qdata(long /*int*/ object, int quark);
public static final synchronized native long /*int*/ g_object_ref(long /*int*/ object);
public static final synchronized native void g_object_set(long /*int*/ object, byte[] first_property_name, boolean data, int terminator);
public static final synchronized native void g_object_set(long /*int*/ object, byte[] first_property_name, int data, int terminator);
public static final synchronized native void g_object_set(long /*int*/ object, byte[] first_property_name, float data, int terminator);
public static final synchronized native void g_object_set_qdata(long /*int*/ object, int quark, long /*int*/ data);
public static final synchronized native void g_object_unref(long /*int*/ object);
public static final synchronized native int g_quark_from_string(byte[] string);
public static final synchronized native int g_signal_connect(long /*int*/ instance, byte[] detailed_signal, long /*int*/ proc, long /*int*/ data);
public static final synchronized native int g_signal_connect_after(long /*int*/ instance, byte[] detailed_signal, long /*int*/ proc, long /*int*/ data);
public static final synchronized native void g_signal_emit_by_name(long /*int*/ instance, byte[] detailed_signal);
public static final synchronized native void g_signal_emit_by_name(long /*int*/ instance, byte[] detailed_signal, long /*int*/ data);
public static final synchronized native void g_signal_emit_by_name(long /*int*/ instance, byte[] detailed_signal, long /*int*/ data1, long /*int*/ data2);
public static final synchronized native void g_signal_emit_by_name(long /*int*/ instance, byte[] detailed_signal, byte [] data);
public static final synchronized native void g_signal_handler_disconnect(long /*int*/ instance, int handler_id);
public static final synchronized native int g_signal_handlers_block_matched(long /*int*/ instance, int mask, int signal_id, int detail, long /*int*/ closure, long /*int*/ func, long /*int*/ data);
public static final synchronized native int g_signal_handlers_disconnect_matched(long /*int*/ instance, int mask, int signal_id, int detail, long /*int*/ closure, long /*int*/ func, long /*int*/ data);
public static final synchronized native int g_signal_handlers_unblock_matched(long /*int*/ instance, int mask, int signal_id, int detail, long /*int*/ closure, long /*int*/ func, long /*int*/ data);
public static final synchronized native int g_signal_lookup (byte[] name, long /*int*/ itype);
public static final synchronized native void g_signal_stop_emission_by_name(long /*int*/ instance, byte[] detailed_signal);
public static final synchronized native long /*int*/ g_slist_next(long /*int*/ list);
public static final synchronized native long /*int*/ g_slist_data(long /*int*/ list);
public static final synchronized native void g_strfreev(long /*int*/ string_array);
public static final synchronized native void g_thread_init(long /*int*/ vtable);
public static final synchronized native boolean g_thread_supported();
public static final synchronized native long /*int*/ g_utf16_to_utf8(char[] str, long /*int*/ len, long /*int*/[] items_read, long /*int*/[] items_written, long /*int*/[] error);
public static final synchronized native long /*int*/ g_utf8_offset_to_pointer(long /*int*/ str, long /*int*/ offset);
public static final synchronized native long /*int*/ g_utf8_pointer_to_offset(long /*int*/ str, long /*int*/ pos);
public static final synchronized native long /*int*/ g_utf8_strlen(long /*int*/ str, long /*int*/ max);
public static final synchronized native long /*int*/ g_utf8_to_utf16(byte[] str, long /*int*/ len, long /*int*/[] items_read, long /*int*/[] items_written, long /*int*/[] error);
public static final synchronized native long /*int*/ g_utf8_to_utf16(long /*int*/ str, long /*int*/ len, long /*int*/[] items_read, long /*int*/[] items_written, long /*int*/[] error);
public static final synchronized native long /*int*/ gdk_atom_intern(byte[] atom_name, boolean only_if_exists);
public static final synchronized native long /*int*/ gdk_atom_name(long /*int*/ atom);
public static final synchronized native void gdk_beep();
public static final synchronized native long /*int*/ gdk_bitmap_create_from_data(long /*int*/ window, byte[] data, int width, int height);
public static final synchronized native boolean gdk_color_white(long /*int*/ colormap, GdkColor color);
public static final synchronized native boolean gdk_colormap_alloc_color(long /*int*/ colormap, GdkColor color, boolean writeable, boolean best_match);
public static final synchronized native void gdk_colormap_free_colors(long /*int*/ colormap, GdkColor colors, int ncolors);
public static final synchronized native long /*int*/ gdk_colormap_get_system();
public static final synchronized native void gdk_colormap_query_color(long /*int*/ colormap, long /*int*/ pixel, GdkColor result);
public static final synchronized native void gdk_cursor_destroy(long /*int*/ cursor);
public static final synchronized native long /*int*/ gdk_cursor_new(long /*int*/ cursor_type);
public static final synchronized native long /*int*/ gdk_cursor_new_from_pixmap(long /*int*/ source, long /*int*/ mask, GdkColor fg, GdkColor bg, int x, int y);
public static final synchronized native void gdk_drag_status(long /*int*/ context, int action, int time);
public static final synchronized native void gdk_draw_arc(long /*int*/ drawable, long /*int*/ gc, int filled, int x, int y, int width, int height, int angle1, int angle2);
public static final synchronized native void gdk_draw_drawable(long /*int*/ drawable, long /*int*/ gc, long /*int*/ src, int xsrc, int ysrc, int xdest, int ydest, int width, int height);
public static final synchronized native void gdk_draw_layout(long /*int*/ drawable, long /*int*/ gc, int x, int y, long /*int*/ layout);
public static final synchronized native void gdk_draw_layout_with_colors(long /*int*/ drawable, long /*int*/ gc, int x, int y, long /*int*/ layout, GdkColor foreground, GdkColor background);
public static final synchronized native void gdk_draw_line(long /*int*/ drawable, long /*int*/ gc, int x1, int y1, int x2, int y2);
public static final synchronized native void gdk_draw_lines(long /*int*/ drawable, long /*int*/ gc, int[] points, int npoints);
public static final synchronized native void gdk_draw_point(long /*int*/ drawable, long /*int*/ gc, int x, int y);
public static final synchronized native void gdk_draw_polygon(long /*int*/ drawable, long /*int*/ gc, int filled, int[] points, int npoints);
public static final synchronized native void gdk_draw_rectangle(long /*int*/ drawable, long /*int*/ gc, int filled, int x, int y, int width, int height);
public static final synchronized native long /*int*/ gdk_drawable_get_image(long /*int*/ drawable, int x, int y, int width, int height);
public static final synchronized native void gdk_drawable_get_size(long /*int*/ drawable, int[] width, int[] height);
public static final synchronized native long /*int*/ gdk_drawable_get_visible_region(long /*int*/ drawable);
public static final synchronized native long /*int*/ gdk_event_copy(long /*int*/ event);
public static final synchronized native void gdk_event_free(long /*int*/ event);
public static final synchronized native long /*int*/ gdk_event_get();
public static final synchronized native boolean gdk_event_get_root_coords(long /*int*/ event, double[] px, double[] py);
public static final synchronized native boolean gdk_event_get_coords(long /*int*/ event, double[] px, double[] py);
public static final synchronized native long /*int*/ gdk_event_get_graphics_expose(long /*int*/ window);
public static final synchronized native boolean gdk_event_get_state(long /*int*/ event, int[] pmod);
public static final synchronized native int gdk_event_get_time(long /*int*/ event);
public static final synchronized native void gdk_event_handler_set(long /*int*/ func, long /*int*/ data, long /*int*/ notify);
public static final synchronized native void gdk_event_put(long /*int*/ event);
public static final synchronized native void gdk_error_trap_push();
public static final synchronized native int gdk_error_trap_pop();
public static final synchronized native void gdk_flush();
public static final synchronized native void gdk_free_text_list(long /*int*/ list);
public static final synchronized native void gdk_gc_get_values(long /*int*/ gc, GdkGCValues values);
public static final synchronized native long /*int*/ gdk_gc_new(long /*int*/ window);
public static final synchronized native void gdk_gc_set_background(long /*int*/ gc, GdkColor color);
public static final synchronized native void gdk_gc_set_clip_mask(long /*int*/ gc, long /*int*/ mask);
public static final synchronized native void gdk_gc_set_clip_origin(long /*int*/ gc, int x, int y);
public static final synchronized native void gdk_gc_set_clip_rectangle(long /*int*/ gc, GdkRectangle rectangle);
public static final synchronized native void gdk_gc_set_clip_region(long /*int*/ gc, long /*int*/ region);
public static final synchronized native void gdk_gc_set_dashes(long /*int*/ gc, int dash_offset, byte[] dash_list, int n);
public static final synchronized native void gdk_gc_set_exposures(long /*int*/ gc, boolean exposures);
public static final synchronized native void gdk_gc_set_fill(long /*int*/ gc, int fill);
public static final synchronized native void gdk_gc_set_foreground(long /*int*/ gc, GdkColor color);
public static final synchronized native void gdk_gc_set_function(long /*int*/ gc, long /*int*/ function);
public static final synchronized native void gdk_gc_set_line_attributes(long /*int*/ gc, int line_width, int line_style, int cap_style, int join_style);
public static final synchronized native void gdk_gc_set_stipple(long /*int*/ gc, long /*int*/ stipple);
public static final synchronized native void gdk_gc_set_subwindow(long /*int*/ gc, long /*int*/ mode);
public static final synchronized native void gdk_gc_set_values(long /*int*/ gc, GdkGCValues values, int values_mask);
public static final synchronized native long /*int*/ gdk_image_get(long /*int*/ window, int x, int y, int width, int height);
public static final synchronized native long /*int*/ gdk_image_get_pixel(long /*int*/ image, int x, int y);
public static final synchronized native void gdk_keyboard_ungrab(int time);
public static final synchronized native long /*int*/ gdk_keymap_get_default();
public static final synchronized native boolean gdk_keymap_translate_keyboard_state (long /*int*/ keymap, int hardware_keycode, int state, int group, int[] keyval, int[] effective_group, int[] level,  int[] consumed_modifiers);
public static final synchronized native int gdk_keyval_to_lower(int keyval);
public static final synchronized native int gdk_keyval_to_unicode(int keyval);
public static final synchronized native long /*int*/ gdk_pango_context_get();
public static final synchronized native void gdk_pango_context_set_colormap(long /*int*/ context, long /*int*/ colormap);
public static final synchronized native long /*int*/ gdk_pango_layout_get_clip_region(long /*int*/ layout, int x_origin, int y_origin, int[] index_ranges, int n_ranges);
public static final synchronized native long /*int*/ gdk_pixbuf_get_from_drawable(long /*int*/ dest, long /*int*/ src, long /*int*/ cmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height);
public static final synchronized native long /*int*/ gdk_pixbuf_get_pixels(long /*int*/ pixbuf);
public static final synchronized native int gdk_pixbuf_get_rowstride(long /*int*/ pixbuf);
public static final synchronized native long /*int*/ gdk_pixbuf_new(int colorspace, boolean has_alpha, int bits_per_sample, int width, int height);
public static final synchronized native void gdk_pixbuf_render_to_drawable(long /*int*/ pixbuf, long /*int*/ drawable, long /*int*/ gc, int src_x, int src_y, int dest_x, int dest_y, int width, int height, int dither, int x_dither, int y_dither);
public static final synchronized native void gdk_pixbuf_render_to_drawable_alpha(long /*int*/ pixbuf, long /*int*/ drawable, int src_x, int src_y, int dest_x, int dest_y, int width, int height, int alpha_mode, int alpha_threshold, int dither, int x_dither, int y_dither);
public static final synchronized native void gdk_pixbuf_render_pixmap_and_mask(long /*int*/ pixbuf, long /*int*/[] pixmap_return, long /*int*/[] mask_return, int alpha_threshold);
public static final synchronized native void gdk_pixbuf_scale(long /*int*/ src, long /*int*/ dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, int interp_type);
public static final synchronized native long /*int*/ gdk_pixbuf_scale_simple(long /*int*/ src, int dest_width, int dest_height, int interp_type);
public static final synchronized native long /*int*/ gdk_pixmap_new(long /*int*/ window, int width, int height, int depth);
public static final synchronized native int gdk_pointer_grab(long /*int*/ window, boolean owner_events, int event_mask, long /*int*/ confine_to, long /*int*/ cursor, int time);
public static final synchronized native boolean gdk_pointer_is_grabbed();
public static final synchronized native void gdk_pointer_ungrab(int time);
public static final synchronized native boolean gdk_property_get(long /*int*/ window, long /*int*/ property, long /*int*/ type, long /*int*/ offset, long /*int*/ length, int pdelete, long /*int*/[] actual_property_type, int[] actual_format, int[] actual_length, long /*int*/[] data);
public static final synchronized native void gdk_region_destroy(long /*int*/ region);
public static final synchronized native boolean gdk_region_empty(long /*int*/ region);
public static final synchronized native void gdk_region_get_clipbox(long /*int*/ region, GdkRectangle rectangle);
public static final synchronized native void gdk_region_get_rectangles(long /*int*/ region, long /*int*/[] rectangles, int[] n_rectangles);
public static final synchronized native void gdk_region_intersect(long /*int*/ source1, long /*int*/ source2);
public static final synchronized native long /*int*/ gdk_region_new();
public static final synchronized native void gdk_region_offset(long /*int*/ region, int dx, int dy);
public static final synchronized native boolean gdk_region_point_in(long /*int*/ region, int x, int y);
public static final synchronized native long /*int*/ gdk_region_polygon(int[] points, int npoints, int fill_rule);
public static final synchronized native long /*int*/ gdk_region_rectangle(GdkRectangle rectangle);
public static final synchronized native long /*int*/ gdk_region_rect_in(long /*int*/ region, GdkRectangle rect);
public static final synchronized native void gdk_region_subtract(long /*int*/ source1, long /*int*/ source2);
public static final synchronized native void gdk_region_union(long /*int*/ source1, long /*int*/ source2);
public static final synchronized native void gdk_region_union_with_rect(long /*int*/ region, GdkRectangle rect);
public static final synchronized native void gdk_rgb_init();
public static final synchronized native long /*int*/ gdk_screen_get_default();
public static final synchronized native int gdk_screen_get_monitor_at_window(long /*int*/ screen, long /*int*/ window);
public static final synchronized native void gdk_screen_get_monitor_geometry (long /*int*/ screen, int monitor_num, GdkRectangle dest);
public static final synchronized native int gdk_screen_get_n_monitors(long /*int*/ screen);
public static final synchronized native int gdk_screen_get_number(long /*int*/ screen);
public static final synchronized native int gdk_screen_height();
public static final synchronized native int gdk_screen_width();
public static final synchronized native int gdk_screen_width_mm();
public static final synchronized native void gdk_set_program_class(byte[] program_class);
public static final synchronized native boolean gdk_utf8_to_compound_text(byte[] str, long /*int*/[] encoding, int[] format, long /*int*/[] ctext, int[] length);
public static final synchronized native int gdk_text_property_to_utf8_list  (long /*int*/ encoding, int format, long /*int*/ text, int length,  long /*int*/[] list);
public static final synchronized native void gdk_threads_enter();
public static final synchronized native void gdk_threads_init();
public static final synchronized native void gdk_threads_leave();
public static final synchronized native  int gdk_unicode_to_keyval(int wc);
public static final synchronized native long /*int*/ gdk_visual_get_system();
public static final synchronized native long /*int*/ gdk_window_at_pointer(int[] win_x, int[] win_y);
public static final synchronized native void gdk_window_begin_paint_rect(long /*int*/ window, GdkRectangle rectangle);
public static final synchronized native void gdk_window_destroy(long /*int*/ window);
public static final synchronized native void gdk_window_end_paint(long /*int*/ window);
public static final synchronized native long /*int*/ gdk_window_get_children(long /*int*/ window);
public static final synchronized native int gdk_window_get_events(long /*int*/ window);
public static final synchronized native void gdk_window_focus(long /*int*/ window, int timestamp);
public static final synchronized native void gdk_window_freeze_updates(long /*int*/ window);
public static final synchronized native void gdk_window_get_frame_extents(long /*int*/ window, GdkRectangle rect);
public static final synchronized native int gdk_window_get_origin(long /*int*/ window, int[] x, int[] y);
public static final synchronized native long /*int*/ gdk_window_get_parent(long /*int*/ window);
public static final synchronized native long /*int*/ gdk_window_get_pointer(long /*int*/ window, int[] x, int[] y, int[] mask);
public static final synchronized native void gdk_window_get_user_data(long /*int*/ window, long /*int*/[] data);
public static final synchronized native void gdk_window_hide(long /*int*/ window);
public static final synchronized native void gdk_window_invalidate_rect(long /*int*/ window, GdkRectangle rectangle, boolean invalidate_children);
public static final synchronized native void gdk_window_invalidate_region(long /*int*/ window, long /*int*/ region, boolean invalidate_children);
public static final synchronized native void gdk_window_move(long /*int*/ window, int x, int y);
public static final synchronized native long /*int*/ gdk_window_new(long /*int*/ parent, GdkWindowAttr attributes, int attributes_mask);
public static final synchronized native void gdk_window_lower(long /*int*/ window);
public static final synchronized native void gdk_window_process_all_updates();
public static final synchronized native void gdk_window_process_updates(long /*int*/ window, boolean update_children);
public static final synchronized native void gdk_window_raise(long /*int*/ window);
public static final synchronized native void gdk_window_resize(long /*int*/ window, int width, int height);
public static final synchronized native void gdk_window_scroll(long /*int*/ window, int dx, int dy);
public static final synchronized native void gdk_window_set_accept_focus(long /*int*/ window, boolean accept_focus);
public static final synchronized native void gdk_window_set_back_pixmap(long /*int*/ window, long /*int*/ pixmap, boolean parent_relative);
public static final synchronized native void gdk_window_set_cursor(long /*int*/ window, long /*int*/ cursor);
public static final synchronized native void gdk_window_set_decorations(long /*int*/ window, int decorations);
public static final synchronized native void gdk_window_set_events(long /*int*/ window, int event_mask);
public static final synchronized native void gdk_window_set_icon(long /*int*/ window, long /*int*/ icon_window, long /*int*/ pixmap, long /*int*/ mask);
public static final synchronized native void gdk_window_set_icon_list(long /*int*/ window, long /*int*/ pixbufs);
public static final synchronized native void gdk_window_set_keep_above(long /*int*/ window, boolean setting);
public static final synchronized native void gdk_window_set_override_redirect(long /*int*/ window, boolean override_redirect);
public static final synchronized native void gdk_window_set_user_data(long /*int*/ window, long /*int*/ user_data);
public static final synchronized native void gdk_window_shape_combine_region (long /*int*/ window, long /*int*/  shape_region, int offset_x,  int offset_y);
public static final synchronized native void gdk_window_show(long /*int*/ window);
public static final synchronized native void gdk_window_thaw_updates(long /*int*/ window);
public static final synchronized native long /*int*/ gtk_accel_group_new();
public static final synchronized native boolean gtk_accel_groups_activate(long /*int*/ accelGroup, int accelKey, int accelMods);
public static final synchronized native void gtk_accel_label_set_accel_widget(long /*int*/ accel_label, long /*int*/ accel_widget);
public static final synchronized native void gtk_adjustment_changed(long /*int*/ adjustment);
public static final synchronized native long /*int*/ gtk_adjustment_new(double value, double lower, double upper, double step_increment, double page_increment, double page_size);
public static final synchronized native void gtk_adjustment_set_value(long /*int*/ adjustment, double value);
public static final synchronized native void gtk_adjustment_value_changed(long /*int*/ adjustment);
public static final synchronized native long /*int*/ gtk_arrow_new(int arrow_type, int shadow_type);
public static final synchronized native void gtk_arrow_set(long /*int*/ arrow, int arrow_type, int shadow_type);
public static final synchronized native long /*int*/ gtk_bin_get_child(long /*int*/ bin);
public static final synchronized native long /*int*/ gtk_button_new();
public static final synchronized native void gtk_button_set_relief(long /*int*/ button, int newstyle);
public static final synchronized native void gtk_cell_renderer_get_size(long /*int*/ cell, long /*int*/ widget, GdkRectangle area, int[] x_offset, int[] y_offset, int[] width, int[] height);
public static final synchronized native long /*int*/ gtk_cell_renderer_pixbuf_new();
public static final synchronized native long /*int*/ gtk_cell_renderer_text_new();
public static final synchronized native long /*int*/ gtk_cell_renderer_toggle_new();
public static final synchronized native long /*int*/ gtk_check_button_new();
public static final synchronized native boolean gtk_check_menu_item_get_active(long /*int*/ wid);
public static final synchronized native long /*int*/ gtk_check_menu_item_new_with_label(byte[] label);
public static final synchronized native void gtk_check_menu_item_set_active(long /*int*/ wid, boolean active);
public static final synchronized native long /*int*/ gtk_check_version(int required_major, int required_minor, int required_micro);
public static final synchronized native void gtk_clipboard_clear(long /*int*/ clipboard);
public static final synchronized native long /*int*/ gtk_clipboard_get(long /*int*/ selection);
public static final synchronized native boolean gtk_clipboard_set_with_data(long /*int*/ clipboard, long /*int*/ target, int n_targets, long /*int*/ get_func, long /*int*/ clear_func, long /*int*/ user_data);
public static final synchronized native long /*int*/ gtk_clipboard_wait_for_contents(long /*int*/ clipboard, long /*int*/ target);
public static final synchronized native long /*int*/ gtk_color_selection_dialog_new(byte[] title);
public static final synchronized native void gtk_color_selection_get_current_color(long /*int*/ colorsel, GdkColor color);
public static final synchronized native void gtk_color_selection_set_current_color(long /*int*/ colorsel, GdkColor color);
public static final synchronized native void gtk_combo_disable_activate(long /*int*/ combo);
public static final synchronized native long /*int*/ gtk_combo_new();
public static final synchronized native void gtk_combo_set_case_sensitive(long /*int*/ combo, boolean val);
public static final synchronized native void gtk_combo_set_popdown_strings(long /*int*/ combo, long /*int*/ strings);
public static final synchronized native void gtk_container_add(long /*int*/ container, long /*int*/ widget);
public static final synchronized native int gtk_container_get_border_width(long /*int*/ container);
public static final synchronized native long /*int*/ gtk_container_get_children(long /*int*/ container);
public static final synchronized native void gtk_container_remove(long /*int*/ container, long /*int*/ widget);
public static final synchronized native void gtk_container_resize_children(long /*int*/ container);
public static final synchronized native void gtk_container_set_border_width(long /*int*/ container, int border_width);
public static final synchronized native long /*int*/ gtk_dialog_add_button(long /*int*/ dialog, String button_text, int response_id);
public static final synchronized native int gtk_dialog_run(long /*int*/ dialog);
public static final synchronized native long /*int*/ gtk_drag_begin(long /*int*/ widget, long /*int*/ targets, int actions, int button, long /*int*/ event);
public static final synchronized native boolean gtk_drag_check_threshold(long /*int*/ widget, int start_x, int start_y, int current_x, int current_y);
public static final synchronized native long /*int*/ gtk_drag_dest_find_target(long /*int*/ widget, long /*int*/ context, long /*int*/ target_list);
public static final synchronized native void gtk_drag_dest_set(long /*int*/ widget, int flags, long /*int*/ targets, int n_targets, int actions);
public static final synchronized native void gtk_drag_dest_unset(long /*int*/ widget);
public static final synchronized native void gtk_drag_finish(long /*int*/ context, boolean success, boolean delete, int time);
public static final synchronized native void gtk_drag_get_data(long /*int*/ widget, long /*int*/ context, long /*int*/ target, int time);
public static final synchronized native long /*int*/ gtk_drawing_area_new();
public static final synchronized native void gtk_editable_copy_clipboard(long /*int*/ editable);
public static final synchronized native void gtk_editable_cut_clipboard(long /*int*/ editable);
public static final synchronized native void gtk_editable_delete_selection(long /*int*/ editable);
public static final synchronized native void gtk_editable_delete_text(long /*int*/ editable, int start_pos, int end_pos);
public static final synchronized native long /*int*/ gtk_editable_get_chars(long /*int*/ editable, int start_pos, int end_pos);
public static final synchronized native boolean gtk_editable_get_editable(long /*int*/ editable);
public static final synchronized native int gtk_editable_get_position(long /*int*/ editable);
public static final synchronized native boolean gtk_editable_get_selection_bounds(long /*int*/ editable, int[] start, int[] end);
public static final synchronized native void gtk_editable_insert_text(long /*int*/ editable, byte[] new_text, int new_text_length, int[] position);
public static final synchronized native void gtk_editable_paste_clipboard(long /*int*/ editable);
public static final synchronized native void gtk_editable_select_region(long /*int*/ editable, int start, int end);
public static final synchronized native void gtk_editable_set_editable(long /*int*/ entry, boolean editable);
public static final synchronized native void gtk_editable_set_position(long /*int*/ editable, int position);
public static final synchronized native char gtk_entry_get_invisible_char(long /*int*/ entry);
public static final synchronized native long /*int*/ gtk_entry_get_layout (long /*int*/ entry);
public static final synchronized native int gtk_entry_get_max_length(long /*int*/ entry);
public static final synchronized native long /*int*/ gtk_entry_get_text(long /*int*/ entry);
public static final synchronized native boolean gtk_entry_get_visibility(long /*int*/ entry);
public static final synchronized native long /*int*/ gtk_entry_new();
public static final synchronized native void gtk_entry_set_activates_default(long /*int*/ entry, boolean setting);
public static final synchronized native void gtk_entry_set_alignment(long /*int*/ entry, float xalign);
public static final synchronized native void gtk_entry_set_has_frame(long /*int*/ entry, boolean setting);
public static final synchronized native void gtk_entry_set_invisible_char(long /*int*/ entry, char ch);
public static final synchronized native void gtk_entry_set_max_length(long /*int*/ entry, int max);
public static final synchronized native void gtk_entry_set_text(long /*int*/ entry, byte[] text);
public static final synchronized native void gtk_entry_set_visibility(long /*int*/ entry, boolean visible);
public static final synchronized native int gtk_events_pending();
public static final synchronized native void gtk_file_selection_complete(long /*int*/ filesel, byte[] pattern);
public static final synchronized native long /*int*/ gtk_file_selection_get_filename(long /*int*/ filesel);
public static final synchronized native long /*int*/ gtk_file_selection_get_selections(long /*int*/ filesel);
public static final synchronized native void gtk_file_selection_hide_fileop_buttons(long /*int*/ filesel);
public static final synchronized native long /*int*/ gtk_file_selection_new(byte[] title);
public static final synchronized native void gtk_file_selection_set_filename(long /*int*/ filesel, long /*int*/ filename);
public static final synchronized native void gtk_file_selection_set_select_multiple(long /*int*/ filesel, boolean select_multiple);
public static final synchronized native void gtk_fixed_move(long /*int*/ fixed, long /*int*/ widget, int x, int y);
public static final synchronized native long /*int*/ gtk_fixed_new();
public static final synchronized native void gtk_fixed_set_has_window(long /*int*/ fixed, boolean has_window);
public static final synchronized native long /*int*/ gtk_font_selection_dialog_get_font_name(long /*int*/ fsd);
public static final synchronized native long /*int*/ gtk_font_selection_dialog_new(byte[] title);
public static final synchronized native boolean gtk_font_selection_dialog_set_font_name(long /*int*/ fsd, byte[] fontname);
public static final synchronized native long /*int*/ gtk_frame_new(byte[] label);
public static final synchronized native long /*int*/ gtk_frame_get_label_widget(long /*int*/ frame);
public static final synchronized native void gtk_frame_set_label(long /*int*/ frame, byte[] label);
public static final synchronized native void gtk_frame_set_label_widget(long /*int*/ frame, long /*int*/ label_widget);
public static final synchronized native void gtk_frame_set_shadow_type(long /*int*/ frame, int type);
public static final synchronized native long /*int*/ gtk_get_current_event();
public static final synchronized native boolean gtk_get_current_event_state (int[] state);
public static final synchronized native int gtk_get_current_event_time();
public static final synchronized native long /*int*/ gtk_get_default_language();
public static final synchronized native long /*int*/ gtk_get_event_widget(long /*int*/ event);
public static final synchronized native void gtk_grab_add(long /*int*/ widget);
public static final synchronized native long /*int*/ gtk_grab_get_current();
public static final synchronized native void gtk_grab_remove(long /*int*/ widget);
public static final synchronized native long /*int*/ gtk_hbox_new(boolean homogeneous, int spacing);
public static final synchronized native long /*int*/ gtk_hscale_new(long /*int*/ adjustment);
public static final synchronized native long /*int*/ gtk_hscrollbar_new(long /*int*/ adjustment);
public static final synchronized native long /*int*/ gtk_hseparator_new();
public static final synchronized native long /*int*/ gtk_icon_factory_lookup_default(byte[] stock_id);
public static final synchronized native long /*int*/ gtk_icon_set_render_icon(long /*int*/ icon_set, long /*int*/ style, int direction, int state, int size, long /*int*/ widget, long /*int*/ detail);
public static final synchronized native boolean gtk_im_context_filter_keypress(long /*int*/ context, long /*int*/ event);
public static final synchronized native void gtk_im_context_focus_in(long /*int*/ context);
public static final synchronized native void gtk_im_context_focus_out(long /*int*/ context);
public static final synchronized native void gtk_im_context_get_preedit_string(long /*int*/ context, long /*int*/[] str, long /*int*/[] attrs, int[] cursor_pos);
public static final synchronized native long /*int*/ gtk_im_context_get_type();
public static final synchronized native void gtk_im_context_reset(long /*int*/ context);
public static final synchronized native void gtk_im_context_set_client_window(long /*int*/ context, long /*int*/ window);
public static final synchronized native void gtk_im_context_set_cursor_location(long /*int*/ context, GdkRectangle area);
public static final synchronized native void gtk_im_multicontext_append_menuitems (long /*int*/ context, long /*int*/ menushell);
public static final synchronized native long /*int*/ gtk_im_multicontext_new();
public static final synchronized native long /*int*/ gtk_image_menu_item_new_with_label(byte[] label);
public static final synchronized native void gtk_image_menu_item_set_image(long /*int*/ menu_item, long /*int*/ image);
public static final synchronized native long /*int*/ gtk_image_new();
public static final synchronized native long /*int*/ gtk_image_new_from_pixmap(long /*int*/ pixmap, long /*int*/ mask);
public static final synchronized native void gtk_image_set_from_pixmap(long /*int*/ image, long /*int*/ pixmap, long /*int*/ mask);
public static final synchronized native boolean gtk_init_check(long /*int*/[] argc, long /*int*/[] argv);
public static final synchronized native int gtk_label_get_mnemonic_keyval(long /*int*/ label);
public static final synchronized native long /*int*/ gtk_label_new(byte[] label);
public static final synchronized native long /*int*/ gtk_label_new_with_mnemonic(byte[] str);
public static final synchronized native void gtk_label_set_attributes(long /*int*/ label, long /*int*/ attrs);
public static final synchronized native void gtk_label_set_justify(long /*int*/ label, int jtype);
public static final synchronized native void gtk_label_set_line_wrap(long /*int*/ label, boolean wrap);
public static final synchronized native void gtk_label_set_text(long /*int*/ label, long /*int*/ str);
public static final synchronized native void gtk_label_set_text_with_mnemonic(long /*int*/ label, byte[] str);
public static final synchronized native void gtk_list_store_append(long /*int*/ list_store, long /*int*/ iter);
public static final synchronized native void gtk_list_store_clear(long /*int*/ store);
public static final synchronized native void gtk_list_store_insert(long /*int*/ list_store, long /*int*/ iter, int position);
public static final synchronized native long /*int*/ gtk_list_store_newv(int numColumns, long /*int*/[] types);
public static final synchronized native void gtk_list_store_remove(long /*int*/ list_store, long /*int*/ iter);
public static final synchronized native void gtk_list_store_set(long /*int*/ store, long /*int*/ iter, int column, byte[] value, int terminator);
public static final synchronized native void gtk_list_store_set(long /*int*/ store, long /*int*/ iter, int column, int value, int terminator);
public static final synchronized native void gtk_list_store_set(long /*int*/ store, long /*int*/ iter, int column, long value, int terminator);
public static final synchronized native void gtk_list_store_set(long /*int*/ store, long /*int*/ iter, int column, GdkColor value, int terminator);
public static final synchronized native void gtk_list_store_set(long /*int*/ store, long /*int*/ iter, int column, boolean value, int terminator);
public static final synchronized native int gtk_major_version();
public static final synchronized native int gtk_minor_version();
public static final synchronized native int gtk_micro_version();
public static final synchronized native void gtk_main();
public static final synchronized native int gtk_main_iteration();
public static final synchronized native void gtk_main_do_event(long /*int*/ event);
public static final synchronized native long /*int*/ gtk_menu_bar_new();
public static final synchronized native void gtk_menu_item_remove_submenu(long /*int*/ menu_item);
public static final synchronized native void gtk_menu_item_set_submenu(long /*int*/ menu_item, long /*int*/ submenu);
public static final synchronized native long /*int*/ gtk_menu_new();
public static final synchronized native void gtk_menu_popdown(long /*int*/ menu);
public static final synchronized native void gtk_menu_popup(long /*int*/ menu, long /*int*/ parent_menu_shell, long /*int*/ parent_menu_item, long /*int*/ func, long /*int*/ data, int button, int activate_time);
public static final synchronized native void gtk_menu_shell_deactivate(long /*int*/ menu_shell);
public static final synchronized native void gtk_menu_shell_insert(long /*int*/ menu_shell, long /*int*/ child, int position);
public static final synchronized native void gtk_menu_shell_select_item(long /*int*/ menu_shell, long /*int*/ menu_item);
public static final synchronized native long /*int*/ gtk_message_dialog_new(long /*int*/ parent, int flags, int type, int buttons, String message_format);
public static final synchronized native void gtk_misc_set_alignment(long /*int*/ misc, float xalign, float yalign);
public static final synchronized native int gtk_notebook_get_current_page(long /*int*/ notebook);
public static final synchronized native boolean gtk_notebook_get_scrollable(long /*int*/ notebook);
public static final synchronized native void gtk_notebook_insert_page(long /*int*/ notebook, long /*int*/ child, long /*int*/ tab_label, int position);
public static final synchronized native long /*int*/ gtk_notebook_new();
public static final synchronized native void gtk_notebook_remove_page(long /*int*/ notebook, int page_num);
public static final synchronized native void gtk_notebook_set_current_page(long /*int*/ notebook, int page_num);
public static final synchronized native void gtk_notebook_set_scrollable(long /*int*/ notebook, boolean scrollable);
public static final synchronized native void gtk_notebook_set_show_tabs(long /*int*/ notebook, boolean show_tabs);
public static final synchronized native void gtk_notebook_set_tab_pos(long /*int*/ notebook, int pos);
public static final synchronized native void gtk_object_sink(long /*int*/ object);
public static final synchronized native void gtk_paint_handle(long /*int*/ style, long /*int*/ window, int state_type, int shadow_type, GdkRectangle area, long /*int*/ widget, byte[] detail, int x , int y, int width, int height, int orientation);
public static final synchronized native long /*int*/ gtk_plug_get_id(long /*int*/ plug);
public static final synchronized native long /*int*/ gtk_plug_new(long /*int*/ socket_id);
public static final synchronized native long /*int*/ gtk_progress_bar_new();
public static final synchronized native void gtk_progress_bar_pulse(long /*int*/ pbar);
public static final synchronized native void gtk_progress_bar_set_fraction(long /*int*/ pbar, double fraction);
public static final synchronized native void gtk_progress_bar_set_orientation(long /*int*/ pbar, int orientation);
public static final synchronized native long /*int*/ gtk_radio_button_get_group(long /*int*/ radio_button);
public static final synchronized native long /*int*/ gtk_radio_button_new(long /*int*/ group);
public static final synchronized native long /*int*/ gtk_radio_menu_item_new_with_label(long /*int*/ group, byte[] label);
public static final synchronized native long /*int*/ gtk_range_get_adjustment(long /*int*/ range);
public static final synchronized native void gtk_range_set_increments(long /*int*/ range, double step, double page);
public static final synchronized native void gtk_range_set_range(long /*int*/ range, double min, double max);
public static final synchronized native void gtk_range_set_value(long /*int*/ range, double value);
public static final synchronized native void gtk_rc_parse_string(byte[] rc_string);
public static final synchronized native long /*int*/ gtk_rc_style_get_bg_pixmap_name(long /*int*/ style, int index);
public static final synchronized native int gtk_rc_style_get_color_flags(long /*int*/ style, int index);
public static final synchronized native void gtk_rc_style_set_bg(long /*int*/ style, int index, GdkColor color);
public static final synchronized native void gtk_rc_style_set_bg_pixmap_name(long /*int*/ style, int index, long /*int*/ name);
public static final synchronized native void gtk_rc_style_set_color_flags(long /*int*/ style, int index, int flag);
public static final synchronized native void gtk_scale_set_digits(long /*int*/ scale, int digits);
public static final synchronized native void gtk_scale_set_draw_value(long /*int*/ scale, boolean draw_value);
public static final synchronized native long /*int*/ gtk_scrolled_window_get_hadjustment(long /*int*/ scrolled_window);
public static final synchronized native void gtk_scrolled_window_get_policy(long /*int*/ scrolled_window, int[] hscrollbar_policy, int[] vscrollbar_policy);
public static final synchronized native int gtk_scrolled_window_get_shadow_type(long /*int*/ scrolled_window);
public static final synchronized native long /*int*/ gtk_scrolled_window_get_vadjustment(long /*int*/ scrolled_window);
public static final synchronized native long /*int*/ gtk_scrolled_window_new(long /*int*/ hadjustment, long /*int*/ vadjustment);
public static final synchronized native void gtk_scrolled_window_set_placement(long /*int*/ scrolled_window, int placement);
public static final synchronized native void gtk_scrolled_window_set_policy(long /*int*/ scrolled_window, int hscrollbar_policy, int vscrollbar_policy);
public static final synchronized native void gtk_scrolled_window_set_shadow_type(long /*int*/ scrolled_window, int type);
public static final synchronized native void gtk_selection_data_free(long /*int*/ selection_data);
public static final synchronized native void gtk_selection_data_set(long /*int*/ selection_data, long /*int*/ type, int format, long /*int*/ data, int length);
public static final synchronized native long /*int*/ gtk_separator_menu_item_new();
public static final synchronized native long /*int*/ gtk_set_locale();
public static final synchronized native long /*int*/ gtk_socket_get_id(long /*int*/ socket);
public static final synchronized native long /*int*/ gtk_socket_new();
public static final synchronized native void gtk_style_get_base(long /*int*/ style, int index, GdkColor color);
public static final synchronized native void gtk_style_get_black(long /*int*/ style, GdkColor color);
public static final synchronized native void gtk_style_get_bg(long /*int*/ style, int index, GdkColor color);
public static final synchronized native void gtk_style_get_dark(long /*int*/ style, int index, GdkColor color);
public static final synchronized native void gtk_style_get_fg(long /*int*/ style, int index, GdkColor color);
public static final synchronized native long /*int*/ gtk_style_get_font_desc(long /*int*/ style);
public static final synchronized native void gtk_style_get_light(long /*int*/ style, int index, GdkColor color);
public static final synchronized native void gtk_style_get_text(long /*int*/ style, int index, GdkColor color);
public static final synchronized native int gtk_style_get_xthickness(long /*int*/ style);
public static final synchronized native int gtk_style_get_ythickness(long /*int*/ style);
public static final synchronized native long /*int*/ gtk_target_list_new(long /*int*/ targets, int ntargets);
public static final synchronized native void gtk_target_list_unref(long /*int*/ list);
public static final synchronized native void gtk_text_buffer_copy_clipboard(long /*int*/ buffer, long /*int*/ clipboard);
public static final synchronized native void gtk_text_buffer_cut_clipboard(long /*int*/ buffer, long /*int*/ clipboard, boolean default_editable);
public static final synchronized native void gtk_text_buffer_delete(long /*int*/ buffer, byte[] start, byte[] end);
public static final synchronized native void gtk_text_buffer_get_bounds(long /*int*/ buffer, byte[] start, byte[] end);
public static final synchronized native int gtk_text_buffer_get_char_count(long /*int*/ buffer);
public static final synchronized native void gtk_text_buffer_get_end_iter(long /*int*/ buffer, byte[] iter);
public static final synchronized native long /*int*/ gtk_text_buffer_get_insert(long /*int*/ buffer);
public static final synchronized native void gtk_text_buffer_get_iter_at_line(long /*int*/ buffer, byte[] iter, int line_number);
public static final synchronized native void gtk_text_buffer_get_iter_at_mark(long /*int*/ buffer, byte[] iter, long /*int*/ mark);
public static final synchronized native void gtk_text_buffer_get_iter_at_offset(long /*int*/ buffer, byte[] iter, int char_offset);
public static final synchronized native int gtk_text_buffer_get_line_count(long /*int*/ buffer);
public static final synchronized native long /*int*/ gtk_text_buffer_get_selection_bound(long /*int*/ buffer);
public static final synchronized native boolean gtk_text_buffer_get_selection_bounds(long /*int*/ buffer, byte[] start, byte[] end);
public static final synchronized native long /*int*/ gtk_text_buffer_get_text(long /*int*/ buffer, byte[] start, byte[] end, boolean include_hidden_chars);
public static final synchronized native void gtk_text_buffer_insert(long /*int*/ buffer, byte[] iter, byte[] text, int len);
public static final synchronized native void gtk_text_buffer_insert(long /*int*/ buffer, long /*int*/ iter, byte[] text, int len);
public static final synchronized native void gtk_text_buffer_move_mark(long /*int*/ buffer, long /*int*/ mark, byte[] where);
public static final synchronized native void gtk_text_buffer_paste_clipboard(long /*int*/ buffer, long /*int*/ clipboard, byte[] override_location, boolean default_editable);
public static final synchronized native void gtk_text_buffer_place_cursor(long /*int*/ buffer, byte[] where);
public static final synchronized native void gtk_text_buffer_set_text(long /*int*/ buffer, byte[] text, int len);
public static final synchronized native int gtk_text_iter_get_line(byte[] iter);
public static final synchronized native int gtk_text_iter_get_offset(byte[] iter);
public static final synchronized native void gtk_text_view_buffer_to_window_coords(long /*int*/ text_view, int win, int buffer_x, int buffer_y, int[] window_x, int[] window_y);
public static final synchronized native long /*int*/ gtk_text_view_get_buffer(long /*int*/ text_view);
public static final synchronized native boolean gtk_text_view_get_editable(long /*int*/ text_view);
public static final synchronized native void gtk_text_view_get_iter_location(long /*int*/ text_view, byte[] iter, GdkRectangle location);
public static final synchronized native void gtk_text_view_get_line_at_y(long /*int*/ text_view, byte[] target_iter, int y, int[] line_top);
public static final synchronized native void gtk_text_view_get_visible_rect(long /*int*/ text_view, GdkRectangle visible_rect);
public static final synchronized native long /*int*/ gtk_text_view_get_window(long /*int*/ text_view, int win);
public static final synchronized native long /*int*/ gtk_text_view_new();
public static final synchronized native void gtk_text_view_scroll_mark_onscreen(long /*int*/ text_view, long /*int*/ mark);
public static final synchronized native boolean gtk_text_view_scroll_to_iter(long /*int*/ text_view, byte[] iter, double within_margin, boolean use_align, double xalign, double yalign);
public static final synchronized native void gtk_text_view_set_editable(long /*int*/ text_view, boolean setting);
public static final synchronized native void gtk_text_view_set_justification(long /*int*/ text_view, int justification);
public static final synchronized native void gtk_text_view_set_tabs(long /*int*/ text_view, long /*int*/ tabs);
public static final synchronized native void gtk_text_view_set_wrap_mode(long /*int*/ text_view, int wrap_mode);
public static final synchronized native int gtk_timeout_add(int interval, long /*int*/ function, long /*int*/ data);
public static final synchronized native void gtk_timeout_remove(int timeout_handler_id);
public static final synchronized native boolean gtk_toggle_button_get_active(long /*int*/ toggle_button);
public static final synchronized native long /*int*/ gtk_toggle_button_new();
public static final synchronized native void gtk_toggle_button_set_active(long /*int*/ toggle_button, boolean is_active);
public static final synchronized native void gtk_toggle_button_set_mode(long /*int*/ toggle_button, boolean draw_indicator);
public static final synchronized native void gtk_toolbar_insert_widget(long /*int*/ toolbar, long /*int*/ widget, byte[] tooltip_text, byte[] tooltip_private_text, int position);
public static final synchronized native long /*int*/ gtk_toolbar_new();
public static final synchronized native void gtk_toolbar_set_orientation(long /*int*/ toolbar, int orientation);
public static final synchronized native void gtk_tooltips_disable(long /*int*/ tooltips);
public static final synchronized native void gtk_tooltips_enable(long /*int*/ tooltips);
public static final synchronized native long /*int*/ gtk_tooltips_new();
public static final synchronized native void gtk_tooltips_set_tip(long /*int*/ tooltips, long /*int*/ widget, byte[] tip_text, byte[] tip_private);
public static final synchronized native void gtk_tree_model_get(long /*int*/ tree_model, long /*int*/ iter, int column, int[] value, int terminator);
public static final synchronized native void gtk_tree_model_get(long /*int*/ tree_model, long /*int*/ iter, int column, long[] value, int terminator);
public static final synchronized native boolean gtk_tree_model_get_iter(long /*int*/ tree_model, long /*int*/ iter, long /*int*/ path);
public static final synchronized native boolean gtk_tree_model_get_iter_first(long /*int*/ tree_model, long /*int*/ iter);
public static final synchronized native int gtk_tree_model_get_n_columns(long /*int*/ tree_model);
public static final synchronized native long /*int*/ gtk_tree_model_get_path(long /*int*/ tree_model, long /*int*/ iter);
public static final synchronized native long /*int*/ gtk_tree_model_get_type();
public static final synchronized native boolean gtk_tree_model_iter_children(long /*int*/ model, long /*int*/ iter, long /*int*/ parent);
public static final synchronized native int gtk_tree_model_iter_n_children(long /*int*/ model, long /*int*/ iter);
public static final synchronized native boolean gtk_tree_model_iter_next(long /*int*/ model, long /*int*/ iter);
public static final synchronized native boolean gtk_tree_model_iter_nth_child(long /*int*/ tree_model, long /*int*/ iter, long /*int*/ parent, int n);
public static final synchronized native void gtk_tree_path_append_index(long /*int*/ path, int index);
public static final synchronized native void gtk_tree_path_free(long /*int*/ path);
public static final synchronized native int gtk_tree_path_get_depth(long /*int*/ path);
public static final synchronized native long /*int*/ gtk_tree_path_get_indices(long /*int*/ path);
public static final synchronized native long /*int*/ gtk_tree_path_new();
public static final synchronized native long /*int*/ gtk_tree_path_new_first();
public static final synchronized native long /*int*/ gtk_tree_path_new_from_string(byte[] path);
public static final synchronized native long /*int*/ gtk_tree_path_new_from_string(long /*int*/ path);
public static final synchronized native boolean gtk_tree_path_up(long /*int*/ path);
public static final synchronized native boolean gtk_tree_selection_get_selected(long /*int*/ selection, long /*int*/[] model, long /*int*/ iter);
public static final synchronized native long /*int*/ gtk_tree_selection_get_selected_rows(long /*int*/ selection, long /*int*/[] model);
public static final synchronized native boolean gtk_tree_selection_path_is_selected(long /*int*/ selection, long /*int*/ path);
public static final synchronized native void gtk_tree_selection_select_all(long /*int*/ selection);
public static final synchronized native void gtk_tree_selection_select_iter(long /*int*/ selection, long /*int*/ iter);
public static final synchronized native void gtk_tree_selection_selected_foreach(long /*int*/ selection, long /*int*/ func, long /*int*/ data);
public static final synchronized native void gtk_tree_selection_set_mode(long /*int*/ selection, int mode);
public static final synchronized native void gtk_tree_selection_unselect_all(long /*int*/ selection);
public static final synchronized native void gtk_tree_selection_unselect_iter(long /*int*/ selection, long /*int*/ iter);
public static final synchronized native void gtk_tree_store_append(long /*int*/ store, long /*int*/ iter, long /*int*/ parent);
public static final synchronized native void gtk_tree_store_clear(long /*int*/ store);
public static final synchronized native void gtk_tree_store_insert(long /*int*/ store, long /*int*/ iter, long /*int*/ parent, int position);
public static final synchronized native long /*int*/ gtk_tree_store_newv(int numColumns, long /*int*/[] types);
public static final synchronized native void gtk_tree_store_remove(long /*int*/ store, long /*int*/ iter);
public static final synchronized native void gtk_tree_store_set(long /*int*/ store, long /*int*/ iter, int column, byte[] value, int terminator);
public static final synchronized native void gtk_tree_store_set(long /*int*/ store, long /*int*/ iter, int column, int value, int terminator);
public static final synchronized native void gtk_tree_store_set(long /*int*/ store, long /*int*/ iter, int column, long value, int terminator);
public static final synchronized native void gtk_tree_store_set(long /*int*/ store, long /*int*/ iter, int column, GdkColor value, int terminator);
public static final synchronized native void gtk_tree_store_set(long /*int*/ store, long /*int*/ iter, int column, boolean value, int terminator);
public static final synchronized native boolean gtk_tree_view_collapse_row(long /*int*/ view, long /*int*/ path);
public static final synchronized native void gtk_tree_view_column_add_attribute(long /*int*/ treeColumn, long /*int*/ cellRenderer, String attribute, int column);
public static final synchronized native boolean gtk_tree_view_column_cell_get_position(long /*int*/ tree_column, long /*int*/ cell_renderer, int[] start_pos, int[] width);
public static final synchronized native void gtk_tree_view_column_cell_get_size(long /*int*/ tree_column, GdkRectangle cell_area, int[] x_offset, int[] y_offset, int[] width, int[] height);
public static final synchronized native void gtk_tree_view_column_cell_set_cell_data(long /*int*/ tree_column, long /*int*/ tree_model, long /*int*/ iter, boolean is_expander, boolean is_expanded);
public static final synchronized native void gtk_tree_view_column_clear(long /*int*/ tree_column);
public static final synchronized native long /*int*/ gtk_tree_view_column_get_cell_renderers(long /*int*/ tree_column);
public static final synchronized native int gtk_tree_view_column_get_fixed_width(long /*int*/ column);
public static final synchronized native boolean gtk_tree_view_column_get_resizable(long /*int*/ column);
public static final synchronized native int gtk_tree_view_column_get_spacing(long /*int*/ tree_column);
public static final synchronized native boolean gtk_tree_view_column_get_visible(long /*int*/ column);
public static final synchronized native int gtk_tree_view_column_get_width(long /*int*/ column);
public static final synchronized native long /*int*/ gtk_tree_view_column_new();
public static final synchronized native void gtk_tree_view_column_pack_start(long /*int*/ tree_column, long /*int*/ cell_renderer, boolean expand);
public static final synchronized native void gtk_tree_view_column_pack_end(long /*int*/ tree_column, long /*int*/ cell_renderer, boolean expand);
public static final synchronized native void gtk_tree_view_column_set_alignment(long /*int*/ tree_column, float xalign);
public static final synchronized native void gtk_tree_view_column_set_cell_data_func(long /*int*/ tree_column, long /*int*/ cell_renderer, long /*int*/ func, long /*int*/ func_data, long /*int*/ destroy);
public static final synchronized native void gtk_tree_view_column_set_clickable(long /*int*/ column, boolean clickable);
public static final synchronized native void gtk_tree_view_column_set_fixed_width(long /*int*/ column, int fixed_width);
public static final synchronized native void gtk_tree_view_column_set_resizable(long /*int*/ column, boolean resizable);
public static final synchronized native void gtk_tree_view_column_set_sizing(long /*int*/ column, int type);
public static final synchronized native void gtk_tree_view_column_set_title(long /*int*/ tree_column, byte[] title);
public static final synchronized native void gtk_tree_view_column_set_visible (long /*int*/ tree_column, boolean visible);
public static final synchronized native void gtk_tree_view_column_set_widget(long /*int*/ tree_column, long /*int*/ widget);
public static final synchronized native void gtk_tree_view_set_drag_dest_row(long /*int*/ view, long /*int*/ path, int pos);
public static final synchronized native boolean gtk_tree_view_expand_row(long /*int*/ view, long /*int*/ path, boolean open_all);
public static final synchronized native long /*int*/ gtk_tree_view_get_bin_window(long /*int*/ tree_view);
public static final synchronized native void gtk_tree_view_get_cell_area(long /*int*/ tree_view, long /*int*/ path, long /*int*/ column, GdkRectangle rect);
public static final synchronized native long /*int*/gtk_tree_view_get_expander_column(long /*int*/ tree_view);
public static final synchronized native long /*int*/ gtk_tree_view_get_column(long /*int*/ tree_view, int n);
public static final synchronized native void gtk_tree_view_get_cursor(long /*int*/ tree_view, long /*int*/[] path, long /*int*/[] focus_column);
public static final synchronized native boolean gtk_tree_view_get_headers_visible(long /*int*/ tree_view);
public static final synchronized native boolean gtk_tree_view_get_path_at_pos(long /*int*/ tree_view, int x, int y, long /*int*/[] path, long /*int*/[] column, int[] cell_x, int[] cell_y);
public static final synchronized native boolean gtk_tree_view_get_rules_hint(long /*int*/ tree_view);
public static final synchronized native long /*int*/ gtk_tree_view_get_selection(long /*int*/ tree_view);
public static final synchronized native void gtk_tree_view_get_visible_rect(long /*int*/ tree_view, GdkRectangle visible_rect);
public static final synchronized native int gtk_tree_view_insert_column(long /*int*/ tree_view, long /*int*/ column, int position);
public static final synchronized native long /*int*/ gtk_tree_view_new_with_model(long /*int*/ model);
public static final synchronized native void gtk_tree_view_remove_column(long /*int*/ tree_view, long /*int*/ column);
public static final synchronized native boolean gtk_tree_view_row_expanded(long /*int*/ view, long /*int*/ path);
public static final synchronized native void gtk_tree_view_scroll_to_cell(long /*int*/ tree_view, long /*int*/ path, long /*int*/ column, boolean use_align, float row_aligh, float column_align);
public static final synchronized native void gtk_tree_view_scroll_to_point (long /*int*/ tree_view, int tree_x, int tree_y);
public static final synchronized native void gtk_tree_view_set_cursor(long /*int*/ tree_view, long /*int*/ path, long /*int*/ focus_column, boolean start_editing); 
public static final synchronized native void gtk_tree_view_set_headers_visible(long /*int*/ tree_view, boolean visible);
public static final synchronized native void gtk_tree_view_set_model(long /*int*/ tree_view, long /*int*/ model);
public static final synchronized native void gtk_tree_view_set_rules_hint(long /*int*/ tree_view, boolean setting);
public static final synchronized native void gtk_tree_view_tree_to_widget_coords(long /*int*/ tree_view, int tx, int ty, int[] wx, int[] wy);
public static final synchronized native void gtk_tree_view_unset_rows_drag_dest(long /*int*/ tree_view);
public static final synchronized native void gtk_tree_view_widget_to_tree_coords(long /*int*/ tree_view, int wx, int wy, int[] tx, int[] ty);
public static final synchronized native long /*int*/ gtk_vbox_new(boolean homogeneous, int spacing);
public static final synchronized native long /*int*/ gtk_vscale_new(long /*int*/ adjustment);
public static final synchronized native long /*int*/ gtk_vscrollbar_new(long /*int*/ adjustment);
public static final synchronized native long /*int*/ gtk_vseparator_new();
public static final synchronized native void gtk_widget_add_accelerator(long /*int*/ widget, byte[] accel_signal, long /*int*/ accel_group, int accel_key, int accel_mods, int accel_flags);
public static final synchronized native void gtk_widget_add_events(long /*int*/ widget, int events);
public static final synchronized native boolean gtk_widget_child_focus(long /*int*/ widget, int direction);
public static final synchronized native long /*int*/ gtk_widget_create_pango_layout(long /*int*/ widget, byte[] text);
public static final synchronized native long /*int*/ gtk_widget_create_pango_layout(long /*int*/ widget, long /*int*/ text);
public static final synchronized native void gtk_widget_destroy(long /*int*/ widget);
public static final synchronized native boolean gtk_widget_event(long /*int*/ widget, long /*int*/ event);
public static final synchronized native int gtk_widget_get_default_direction();
public static final synchronized native long /*int*/ gtk_widget_get_default_style();
public static final synchronized native int gtk_widget_get_direction(long /*int*/ widget);
public static final synchronized native int gtk_widget_get_events(long /*int*/ widget);
public static final synchronized native long /*int*/ gtk_widget_get_modifier_style(long /*int*/ widget);
public static final synchronized native long /*int*/ gtk_widget_get_pango_context(long /*int*/ widget);
public static final synchronized native long /*int*/ gtk_widget_get_parent(long /*int*/ widget);
public static final synchronized native long /*int*/ gtk_widget_get_style(long /*int*/ widget);
public static final synchronized native void gtk_widget_grab_focus(long /*int*/ widget);
public static final synchronized native void gtk_widget_hide(long /*int*/ widget);
public static final synchronized native boolean gtk_widget_is_focus(long /*int*/ widget);
public static final synchronized native boolean gtk_widget_mnemonic_activate(long /*int*/ widget, boolean group_cycling);
public static final synchronized native void gtk_widget_modify_base(long /*int*/ widget, int state, GdkColor color);
public static final synchronized native void gtk_widget_modify_bg(long /*int*/ widget, int state, GdkColor color);
public static final synchronized native void gtk_widget_modify_fg(long /*int*/ widget, int state, GdkColor color);
public static final synchronized native void gtk_widget_modify_font(long /*int*/ widget, long /*int*/ pango_font_descr);
public static final synchronized native void gtk_widget_modify_style(long /*int*/ widget, long /*int*/ style);
public static final synchronized native void gtk_widget_modify_text(long /*int*/ widget, int state, GdkColor color);
public static final synchronized native void gtk_widget_realize(long /*int*/ widget);
public static final synchronized native void gtk_widget_remove_accelerator(long /*int*/ widget, long /*int*/ accel_group, int accel_key, int accel_mods);
public static final synchronized native void gtk_widget_reparent(long /*int*/ widget, long /*int*/ new_parent);
public static final synchronized native void gtk_widget_set_default_direction(int dir); 
public static final synchronized native void gtk_widget_set_direction(long /*int*/ widget, int dir);
public static final synchronized native void gtk_widget_set_double_buffered(long /*int*/ widget, boolean double_buffered);
public static final synchronized native void gtk_widget_set_name(long /*int*/ widget, byte[] name);
public static final synchronized native void gtk_widget_set_redraw_on_allocate(long /*int*/ widget, boolean redraw);
public static final synchronized native void gtk_widget_set_sensitive(long /*int*/ widget, boolean sensitive);
public static final synchronized native void gtk_widget_set_size_request(long /*int*/ widget, int width, int height);
public static final synchronized native void gtk_widget_set_state(long /*int*/ widget, int state);
public static final synchronized native void gtk_widget_shape_combine_mask(long /*int*/ widget, long /*int*/ shape_mask, int offset_x, int offset_y);
public static final synchronized native void gtk_widget_show(long /*int*/ widget);
public static final synchronized native void gtk_widget_show_now(long /*int*/ widget);
public static final synchronized native void gtk_widget_size_allocate(long /*int*/ widget, GtkAllocation allocation);
public static final synchronized native void gtk_widget_size_request(long /*int*/ widget, GtkRequisition requisition);
public static final synchronized native void gtk_widget_style_get(long /*int*/ widget, byte[] property_name, int[] value, int null_terminator);
public static final synchronized native void gtk_widget_unrealize(long /*int*/ widget);
public static final synchronized native boolean gtk_window_activate_default(long /*int*/ window);
public static final synchronized native void gtk_window_add_accel_group(long /*int*/ window, long /*int*/ accel_group);
public static final synchronized native void gtk_window_deiconify(long /*int*/ handle);
public static final synchronized native long /*int*/ gtk_window_get_focus(long /*int*/ window);
public static final synchronized native int gtk_window_get_mnemonic_modifier(long /*int*/ window);
public static final synchronized native void gtk_window_get_position(long /*int*/ handle, int[] x, int[] y);
public static final synchronized native void gtk_window_get_size(long /*int*/ handle, int[] x, int[] y);
public static final synchronized native void gtk_window_iconify(long /*int*/ handle);
public static final synchronized native void gtk_window_maximize(long /*int*/ handle);
public static final synchronized native void gtk_window_move(long /*int*/ handle, int x, int y);
public static final synchronized native long /*int*/ gtk_window_new(int type);
public static final synchronized native void gtk_window_present(long /*int*/ window);
public static final synchronized native void gtk_window_remove_accel_group(long /*int*/ window, long /*int*/ accel_group);
public static final synchronized native void gtk_window_resize(long /*int*/ handle, int x, int y);
public static final synchronized native void gtk_window_set_default(long /*int*/ window, long /*int*/ widget);
public static final synchronized native void gtk_window_set_destroy_with_parent(long /*int*/ window, boolean setting);
public static final synchronized native void gtk_window_set_modal(long /*int*/ window, boolean modal);
public static final synchronized native void gtk_window_set_resizable(long /*int*/ window, boolean resizable);
public static final synchronized native void gtk_window_set_title(long /*int*/ window, byte[] title);
public static final synchronized native void gtk_window_set_type_hint(long /*int*/ window, int hint);
public static final synchronized native void gtk_window_set_transient_for(long /*int*/ window, long /*int*/ parent);
public static final synchronized native void gtk_window_unmaximize(long /*int*/ handle);
public static final native void memmove(long /*int*/ dest, GtkTargetEntry src, long /*int*/ size);
public static final native void memmove(long /*int*/ dest, GtkAdjustment src);
public static final native void memmove(long /*int*/ dest, GdkEventButton src, long /*int*/ size);
public static final native void memmove(long /*int*/ dest, PangoAttribute src, long /*int*/ size);
public static final native void memmove(GtkColorSelectionDialog dest, long /*int*/ src);
public static final native void memmove(GtkFileSelection dest, long /*int*/ src);
public static final native void memmove(GdkDragContext dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GtkSelectionData dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GtkTargetPair dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GtkCombo dest, long /*int*/ src);
public static final native void memmove(GtkAdjustment dest, long /*int*/ src);
public static final native void memmove(GdkColor dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEvent dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventButton dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventCrossing dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventExpose dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventFocus dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventKey dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventMotion dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventVisibility dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GdkEventWindowState dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(GtkFixed dest, long /*int*/ src);
public static final native void memmove(long /*int*/ dest, GtkFixed src);
public static final native void memmove(GdkVisual dest, long /*int*/ src);
public static final native void memmove(GdkImage dest, long /*int*/ src);
public static final native void memmove(GdkRectangle dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(PangoAttribute dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(PangoItem dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(PangoLayoutLine dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(PangoLayoutRun dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(PangoLogAttr dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(long /*int*/ dest, int[] src, long /*int*/ size);
public static final native void memmove(long /*int*/ dest, byte[] src, long /*int*/ size);
public static final native void memmove(int[] dest, byte[] src, long /*int*/ size);
public static final native void memmove(byte[] dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(char[] dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(int[] dest, long /*int*/ src, long /*int*/ size);
public static final native void memmove(long[] dest, long /*int*/ src, long /*int*/ size);
public static final native void memset(long /*int*/ buffer, char c, long /*int*/ num);
public static final synchronized native long /*int*/ pango_attr_background_new (short red, short green, short blue);
public static final synchronized native long /*int*/ pango_attr_font_desc_new(long /*int*/ desc);
public static final synchronized native long /*int*/ pango_attr_foreground_new (short red, short green, short blue);
public static final synchronized native long /*int*/ pango_attr_shape_new(PangoRectangle ink_rect, PangoRectangle logical_rect);
public static final synchronized native void pango_attr_list_insert(long /*int*/ list, long /*int*/ attr);
public static final synchronized native void pango_attr_list_change(long /*int*/ list, long /*int*/ attr);
public static final synchronized native long /*int*/ pango_attr_list_new();
public static final synchronized native void pango_attr_list_unref(long /*int*/ list);
public static final synchronized native long /*int*/ pango_attr_strikethrough_new(boolean strikethrough);
public static final synchronized native long /*int*/ pango_attr_underline_new(int underline);
public static final synchronized native long /*int*/ pango_attr_weight_new(int weight);
public static final synchronized native int pango_context_get_base_dir(long /*int*/ context);
public static final synchronized native long /*int*/ pango_context_get_language(long /*int*/ context);
public static final synchronized native long /*int*/ pango_context_get_metrics(long /*int*/ context, long /*int*/ desc, long /*int*/ language);
public static final synchronized native void pango_context_list_families(long /*int*/ context, long /*int*/[] families, int[] n_families);
public static final synchronized native void pango_context_set_base_dir(long /*int*/ context, int direction);
public static final synchronized native void pango_context_set_language(long /*int*/ context, long /*int*/ language);
public static final synchronized native long /*int*/ pango_font_description_copy(long /*int*/ desc);
public static final synchronized native void pango_font_description_free(long /*int*/ desc);
public static final synchronized native long /*int*/ pango_font_description_from_string(byte[] str);
public static final synchronized native long /*int*/ pango_font_description_get_family(long /*int*/ desc);
public static final synchronized native int pango_font_description_get_size(long /*int*/ desc);
public static final synchronized native int pango_font_description_get_style(long /*int*/ desc);
public static final synchronized native int pango_font_description_get_weight(long /*int*/ desc);
public static final synchronized native long /*int*/ pango_font_description_new();
public static final synchronized native void pango_font_description_set_family(long /*int*/ desc, byte[] family);
public static final synchronized native void pango_font_description_set_size(long /*int*/ desc, int size);
public static final synchronized native void pango_font_description_set_stretch(long /*int*/ desc, int stretch);
public static final synchronized native void pango_font_description_set_style(long /*int*/ desc, int weight);
public static final synchronized native void pango_font_description_set_weight(long /*int*/ desc, int weight);
public static final synchronized native long /*int*/ pango_font_description_to_string(long /*int*/ desc);
public static final synchronized native long /*int*/ pango_font_face_describe(long /*int*/ face);
public static final synchronized native long /*int*/ pango_font_family_get_name (long /*int*/ family);
public static final synchronized native void pango_font_family_list_faces(long /*int*/ family, long /*int*/[] faces, int[] n_faces);
public static final synchronized native long /*int*/ pango_font_get_metrics(long /*int*/ font, long /*int*/ language);
public static final synchronized native int pango_font_metrics_get_approximate_char_width(long /*int*/ metrics);
public static final synchronized native int pango_font_metrics_get_ascent(long /*int*/ metrics);
public static final synchronized native int pango_font_metrics_get_descent(long /*int*/ metrics);
public static final synchronized native void pango_font_metrics_unref(long /*int*/ metrics);
public static final synchronized native long /*int*/ pango_language_from_string(byte[] language);
public static final synchronized native void pango_layout_context_changed (long /*int*/ layout);
public static final synchronized native int pango_layout_get_alignment(long /*int*/ layout);
public static final synchronized native long /*int*/ pango_layout_get_attributes(long /*int*/ layout);
public static final synchronized native long /*int*/ pango_layout_get_iter(long /*int*/ layout);
public static final synchronized native long /*int*/ pango_layout_get_line(long /*int*/ layout, int line);
public static final synchronized native int pango_layout_get_line_count(long /*int*/ layout);
public static final synchronized native void pango_layout_get_log_attrs(long /*int*/ layout, long /*int*/[] attrs, int[] n_attrs);
public static final synchronized native void pango_layout_get_size(long /*int*/ layout, int[] width, int[] height);
public static final synchronized native int pango_layout_get_spacing(long /*int*/ layout);
public static final synchronized native long /*int*/ pango_layout_get_tabs(long /*int*/ layout);
public static final synchronized native long /*int*/ pango_layout_get_text(long /*int*/ layout);
public static final synchronized native int pango_layout_get_width(long /*int*/ layout);
public static final synchronized native void pango_layout_index_to_pos(long /*int*/ layout, int index, PangoRectangle pos);
public static final synchronized native void pango_layout_iter_free(long /*int*/ iter);
public static final synchronized native void pango_layout_iter_get_line_extents(long /*int*/ iter, PangoRectangle ink_rect, PangoRectangle logical_rect);
public static final synchronized native int pango_layout_iter_get_index(long /*int*/ iter);
public static final synchronized native long /*int*/ pango_layout_iter_get_run(long /*int*/ iter);
public static final synchronized native boolean pango_layout_iter_next_line(long /*int*/ iter);
public static final synchronized native boolean pango_layout_iter_next_run(long /*int*/ iter);
public static final synchronized native void pango_layout_line_get_extents(long /*int*/ line, PangoRectangle ink_rect, PangoRectangle logical_rect);
public static final synchronized native boolean pango_layout_line_x_to_index(long /*int*/ line, int x_pos, int[] index_, int[] trailing);
public static final synchronized native long /*int*/ pango_layout_new(long /*int*/ context);
public static final synchronized native void pango_layout_set_alignment (long /*int*/ layout, int alignment);
public static final synchronized native void pango_layout_set_attributes(long /*int*/ layout, long /*int*/ attrs);
public static final synchronized native void pango_layout_set_font_description(long /*int*/ context, long /*int*/ descr);
public static final synchronized native void pango_layout_set_single_paragraph_mode(long /*int*/ context, boolean setting);
public static final synchronized native void pango_layout_set_spacing(long /*int*/ layout, int spacing);
public static final synchronized native void pango_layout_set_tabs(long /*int*/ layout, long /*int*/ tabs);
public static final synchronized native void pango_layout_set_text(long /*int*/ layout, byte[] text, int length);
public static final synchronized native void pango_layout_set_width(long /*int*/ layout, int width);
public static final synchronized native void pango_layout_set_wrap (long /*int*/ layout, int wrap);
public static final synchronized native boolean pango_layout_xy_to_index(long /*int*/ layout, int x, int y, int[] index, int[] trailing);
public static final synchronized native int pango_tab_array_get_size(long /*int*/ tab_array);
public static final synchronized native void pango_tab_array_get_tabs(long /*int*/ tab_array, long /*int*/[] alignments, long /*int*/[] locations);
public static final synchronized native void pango_tab_array_free(long /*int*/ tab_array);
public static final synchronized native long /*int*/ pango_tab_array_new(int initial_size, boolean positions_in_pixels);
public static final synchronized native void pango_tab_array_set_tab(long /*int*/ tab_array, int tab_index, long /*int*/ alignment, int location);
}
